#define _WIN32_WINNT 0x400

#include <windows.h>
#include <WININET.h>
#include <wincrypt.h>
#include <winbase.h>
#include "webdav.h"
#include "davfunc.h"
#include "utils.h"
#include "resource.h"
#include "fsplugin.h"
#include "cvtutf.h"
#include "Base64Encoder.h"

#pragma comment (lib, "crypt32.lib")

#ifndef CERT_NAME_SIMPLE_DISPLAY_TYPE
#define CERT_NAME_SIMPLE_DISPLAY_TYPE   4
#endif

#ifndef CERT_NAME_ISSUER_FLAG
#define CERT_NAME_ISSUER_FLAG           0x1
#define CERT_NAME_DISABLE_IE4_UTF8_FLAG 0x00010000
#endif

#ifndef INTERNET_OPTION_CLIENT_CERT_CONTEXT
#define INTERNET_OPTION_CLIENT_CERT_CONTEXT      84
#endif

// SR: 09.07.2005

// ****************************************************************************
// ******                       Definition zu countof                    ******
// ****************************************************************************
#ifndef countof
#define countof(array) (sizeof(array)/sizeof(array[0]))
#endif // countof

#include <tchar.h>
#define STRSAFE_NO_DEPRECATE

#define SSL_CLIENT_CERTIFICATE_STORE "MY"

void SetSSLCert(void* serverid, HINTERNET hRequest);

// SR: 09.07.2005


extern BOOL UpdatePercentBar(int percent);
extern void ShowStatus(char* status);
extern HINSTANCE hinst;
extern int PluginNumber;
extern tProgressProc ProgressProc;
extern tLogProc LogProc;
extern tRequestProc RequestProc;

int numconnections=0;
BOOL serverfieldchangedbyuser=false;

typedef struct {
	char server[MAX_PATH];
	char user[MAX_PATH];
	char password[MAX_PATH];
	char rootdir[MAX_PATH];
	BOOL SslConnect;
	DWORD SslFlags;
	char SslCertIssuer[MAX_PATH];
	char SslCertSerial[MAX_PATH];
	HCERTSTORE SslCertStore;
	HINTERNET InetHandle;
	HINTERNET ConnHandle;
	int servernamelen;
	int customport;
	BOOL interpreturlasutf8;
	BOOL dialogforconnection;
	BOOL use3stepuploadmethod;
	BOOL usemultistepuploadmethod;
	BOOL deletebeforeupload;
	BOOL detailedlog;
	BOOL apacheDirWithSlash;
	DWORD TempPathUniqueValue;
	int proxytype;   //0=no, 1=default, 2=custom
	char proxyserver[MAX_PATH];
	char proxyuser[MAX_PATH];
	char proxypassword[MAX_PATH];
} tConnectSettings,*pConnectSettings;

//#define propfindxmlbody "\r\n<?xml version=\"1.0\" encoding=\"utf-8\" ?><A:propfind xmlns:A=\"DAV:\"><A:prop><A:getcontentlength/><A:getlastmodified/></A:prop></A:propfind>"
#define propfindxmlbody "\r\n<?xml version=\"1.0\" encoding=\"utf-8\" ?><A:propfind xmlns:A='DAV'><A:prop><A:getcontentlength/><A:getlastmodified/></A:prop></A:propfind>"
//#define datesetxmlbody "\r\n<?xml version=\"1.0\" encoding=\"utf-8\" ?><D:propertyupdate xmlns:D=\"DAV:\" xmlns:srtns=\"http://www.southrivertech,com/\"><D:set><D:prop><srtns:srt_modifiedtime>2008-05-08T07:19:49Z</srtns:srt_modifiedtime></D:prop></D:set></D:propertyupdate>"

typedef struct {
	DWORD dwError;
	HINTERNET hCreatedRequest;
	HANDLE hHandleCreatedEvent;
	HANDLE hRequestCompleteEvent;
	int lastpercent;
} CONTEXTBUF;

int GetPercent(_int64 offset,_int64 filesize)
{
    if (!filesize)
        return 0;
    int percent=(int)(offset*100/filesize);
    if (percent<0) percent=0;
    if (percent>100) percent=100;
	return percent;
}

void ShowDetailedError(char* errorbegin,DWORD err)
{
	char errorbuf[3*MAX_PATH];
	strcpy(errorbuf,errorbegin);
	char* p=errorbuf+strlen(errorbuf);
	DWORD len=sizeof(errorbuf)-(p-errorbuf)-1;
	DWORD err2;
	if (err==ERROR_INTERNET_EXTENDED_ERROR)
		InternetGetLastResponseInfo(&err2,p,&len);
	else if (err) {
		char* lpMsgBuf;
		FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,err,0, // Default language
			(LPTSTR) &lpMsgBuf,0,NULL);
		if (lpMsgBuf && lpMsgBuf[0])
			strlcat(errorbuf,lpMsgBuf,sizeof(errorbuf)-1);
		else {
			if (err>=ERROR_INTERNET_OUT_OF_HANDLES  && err<=ERROR_INTERNET_INSERT_CDROM)
				LoadString(hinst,err,p,sizeof(errorbuf)-1-(p-errorbuf));
			else
				wsprintf(p,"Error %d, FormatMessage error %d",err, GetLastError());
		}
		if (lpMsgBuf)
			LocalFree( lpMsgBuf );
	}
	ShowStatus(errorbuf);
}

void __stdcall DummyCallback(HINTERNET hInternet,DWORD dwContext,DWORD dwInternetStatus,LPVOID lpStatusInfo,DWORD dwStatusInfoLen);
void __stdcall InternetCallback(HINTERNET hInternet,DWORD dwContext,DWORD dwInternetStatus,LPVOID lpStatusInfo,DWORD dwStatusInfoLen);

int WebDavConnect(pConnectSettings ConnectSettings)
{
	WORD wVersionRequested;
	WSADATA wsaData;

	wVersionRequested = MAKEWORD( 1, 1 );

	if (numconnections==0)
		if (WSAStartup( wVersionRequested, &wsaData )==0)
			numconnections=1;
	if (numconnections) {
		if (!ConnectSettings->InetHandle) {
			char* pproxy=NULL;
			int opentype;
			switch (ConnectSettings->proxytype) {
			case 0:
				opentype=INTERNET_OPEN_TYPE_DIRECT;
				break;
			case 2:
				if (ConnectSettings->proxyserver[0]) {
					opentype=INTERNET_OPEN_TYPE_PROXY;
					pproxy=ConnectSettings->proxyserver;
				} else
					opentype=INTERNET_OPEN_TYPE_PRECONFIG;
				break;
			default:
				opentype=INTERNET_OPEN_TYPE_PRECONFIG;
			}

			ConnectSettings->InetHandle=InternetOpen("ezdavplugin",opentype,pproxy,NULL,INTERNET_FLAG_ASYNC);
		}
		if (ConnectSettings->InetHandle) {
			InternetSetStatusCallback(ConnectSettings->InetHandle,(INTERNET_STATUS_CALLBACK)&DummyCallback);

			InternetSetOption(ConnectSettings->InetHandle, INTERNET_OPTION_PROXY_USERNAME,
				ConnectSettings->proxyuser, strlen(ConnectSettings->proxyuser)+1);

			//strPassword is the buffer that contains the proxy password.
			InternetSetOption(ConnectSettings->InetHandle, INTERNET_OPTION_PROXY_PASSWORD,
				ConnectSettings->proxypassword, strlen(ConnectSettings->proxypassword)+1);

			ConnectSettings->servernamelen=strlen(ConnectSettings->server);
			if (ConnectSettings->SslConnect)
			{
				ConnectSettings->ConnHandle=InternetConnect(ConnectSettings->InetHandle,ConnectSettings->server,ConnectSettings->customport,
					ConnectSettings->user,ConnectSettings->password,INTERNET_SERVICE_HTTP,INTERNET_FLAG_SECURE,0);
			}
			else if (ConnectSettings->customport)
				ConnectSettings->ConnHandle=InternetConnect(ConnectSettings->InetHandle,ConnectSettings->server,ConnectSettings->customport,
					ConnectSettings->user,ConnectSettings->password,INTERNET_SERVICE_HTTP,0,0);
			else
				ConnectSettings->ConnHandle=InternetConnect(ConnectSettings->InetHandle,ConnectSettings->server,INTERNET_DEFAULT_HTTP_PORT,
					ConnectSettings->user,ConnectSettings->password,INTERNET_SERVICE_HTTP,0,0);
			if (!ConnectSettings->ConnHandle) {
				ShowDetailedError("InternetConnect failed: ",GetLastError());
				InternetCloseHandle(ConnectSettings->InetHandle);
				ConnectSettings->InetHandle=NULL;
				numconnections--;
			}				
		} else {
			ShowDetailedError("Error: Could not get Internet handle: ",GetLastError());
			numconnections--;
		}
	}
	if (!ConnectSettings->ConnHandle) {
		if (numconnections==0) {
			WSACleanup();
		}
		ConnectSettings->servernamelen=0;
		return DAV_FAILED;
	} else
		return DAV_OK;
}

// SR: 10.07.2005
//char* defOK="<Choose new server type from list>";
//char* defBAD="Could not find file davplug.inc!";

void FillServerList(HWND hWnd)
{
	char listfilename[MAX_PATH];
	BOOL listread=false;
	DWORD size=0;
	char* serverlist=NULL;
	
	GetModuleFileName(hinst,listfilename,MAX_PATH-10);

	char* p=strrchr(listfilename,'\\');
	if (!p) 
		p=listfilename;
	strcpy(p,"\\davplug.inc");
	HANDLE tempfile=CreateFile(listfilename,GENERIC_READ,FILE_SHARE_READ | FILE_SHARE_WRITE,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN,NULL);

	if (tempfile!=INVALID_HANDLE_VALUE) {
		size=GetFileSize(tempfile,NULL);
		if (size) {
			DWORD bytesread=0;
			serverlist=(char*)malloc(size+1);
			if (serverlist)
				if (ReadFile(tempfile,serverlist,size,&bytesread,NULL) && bytesread>0) {
					serverlist[bytesread]=0;
					listread=true;
				}
		}
		CloseHandle(tempfile);
	}
	if (listread) 
	{
		// SR: 10.07.2005
		TCHAR szBuffer[256]; LoadString(hinst, IDS_SERVERLIST_DEFOK, szBuffer, countof(szBuffer));
		SendDlgItemMessage(hWnd,IDC_DEFAULTCOMBO,CB_ADDSTRING,0,(LPARAM)szBuffer);

		char* pitem=strtok(serverlist,"\r");
		while(pitem) {
			if (pitem[0]=='\n')
				pitem++;
			if (pitem[0]!='#') {  // a comment
				char* pitemend=strchr(pitem,',');
				if (pitemend) {
					pitemend[0]=0;
					SendDlgItemMessage(hWnd,IDC_DEFAULTCOMBO,CB_ADDSTRING,0,(LPARAM)pitem);
					pitemend[0]=',';
				}
			}
			pitem=strtok(NULL,"\r");
		}
	} 
	else
	{
		// SR: 10.07.2005
		TCHAR szBuffer[256]; LoadString(hinst, IDS_SERVERLIST_DEFBAD, szBuffer, countof(szBuffer));
		SendDlgItemMessage(hWnd,IDC_DEFAULTCOMBO,CB_ADDSTRING,0,(LPARAM)szBuffer);
	}
	if (size)
		free(serverlist);
}

void FillClientCertList(HWND hWnd, pConnectSettings ConnectResults)
{
	if (ConnectResults->SslConnect)
		EnableWindow(GetDlgItem(hWnd,IDC_CBO_CC), TRUE);

	HCERTSTORE       hCertStore = NULL;
	PCCERT_CONTEXT   pCertContext = NULL;
	char szNameString[MAX_PATH + 1] = "";
	BOOL bFoundCert = FALSE;
	
	SendDlgItemMessage(hWnd,IDC_CBO_CC,CB_ADDSTRING,0,(LPARAM) "");

	hCertStore = CertOpenSystemStore(NULL, SSL_CLIENT_CERTIFICATE_STORE);

	if (hCertStore)
	{
		// CertGetNameString here leads to unresolved external symbol although the required h file and lib 
		// is included... Therefore use LoadLibrary/GetProcAddress
		HMODULE hCryptDll = LoadLibrary("Crypt32.dll");

		if (hCryptDll)
		{
			typedef DWORD (WINAPI* pfnCertGetNameString)(PCCERT_CONTEXT pCertContext, DWORD dwType, DWORD dwFlags,
				                                         void *pvTypePara, LPTSTR pszNameString, DWORD cchNameString);
            pfnCertGetNameString pfnCertGetNameStringProc = reinterpret_cast<pfnCertGetNameString>(GetProcAddress(hCryptDll, "CertGetNameStringA"));

			if (pfnCertGetNameStringProc != NULL)
			{
				while ((pCertContext = CertEnumCertificatesInStore(hCertStore, pCertContext)))
				{
					DWORD dwRet = pfnCertGetNameStringProc(pCertContext, CERT_NAME_SIMPLE_DISPLAY_TYPE,
										                   CERT_NAME_DISABLE_IE4_UTF8_FLAG,
										                   NULL, szNameString, MAX_PATH);
					
					if (dwRet)
					{
						int iIndex = SendDlgItemMessage(hWnd, IDC_CBO_CC, CB_ADDSTRING, 0, (LPARAM) szNameString);

						PCERT_INFO pCertInfo = pCertContext->pCertInfo;

						if (pCertInfo != NULL)
						{
							// Get the serial number in order to search for the cert when connecting...
							CRYPT_INTEGER_BLOB clbSerial = pCertInfo->SerialNumber;

							unsigned int iOut = 0;
							unsigned char* szB64 = base64_encode((const char*) clbSerial.pbData, clbSerial.cbData, &iOut);

							if (szB64 != NULL)
							{
								if (iOut > 0)
								{
									CRYPT_INTEGER_BLOB* clbSerialB64 = new CRYPT_INTEGER_BLOB();
									clbSerialB64->pbData = szB64;
									clbSerialB64->cbData = iOut;

									if (iIndex > -1)
										SendDlgItemMessage(hWnd, IDC_CBO_CC, CB_SETITEMDATA, (WPARAM) iIndex, (LPARAM) clbSerialB64);

									if (stricmp(ConnectResults->SslCertIssuer, szNameString) == 0 && !bFoundCert)
									{
										if (strnicmp(ConnectResults->SslCertSerial, (const char*) szB64, iOut) == 0)
										{
											SendDlgItemMessage(hWnd, IDC_CBO_CC, CB_SETCURSEL, (WPARAM) iIndex, (LPARAM) 0);
											bFoundCert = TRUE;
										}
									}
								}
								else
								{
									free(szB64);
									szB64 = NULL;
								}
							}
						}
					}
				}
			}

			FreeLibrary(hCryptDll);
		}

		CertCloseStore(hCertStore, CERT_CLOSE_STORE_FORCE_FLAG);
		hCertStore = NULL;
	}
}

char* _mytokensource;

char* mystrtok(char* pitem,char token)
{
	char* ret;
	if (pitem)
		ret=pitem;
	else
		ret=_mytokensource;

	if (ret) {
		_mytokensource=strchr(ret,token);
		if (_mytokensource) {
			_mytokensource[0]=0;
			_mytokensource++;
		}
	}
	return ret;
}

void LoadServerSettingsFromList(HWND hWnd,char* servertype,BOOL changeserverfield)
{
	char listfilename[MAX_PATH];
	BOOL listread=false;
	DWORD size=0;
	char* serverlist=NULL;
	
	GetModuleFileName(hinst,listfilename,MAX_PATH-10);

	char* p=strrchr(listfilename,'\\');
	if (!p) 
		p=listfilename;
	strcpy(p,"\\davplug.inc");
	HANDLE tempfile=CreateFile(listfilename,GENERIC_READ,FILE_SHARE_READ | FILE_SHARE_WRITE,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN,NULL);

	if (tempfile!=INVALID_HANDLE_VALUE) {
		size=GetFileSize(tempfile,NULL);
		if (size) {
			DWORD bytesread=0;
			serverlist=(char*)malloc(size+1);
			if (serverlist)
				if (ReadFile(tempfile,serverlist,size,&bytesread,NULL) && bytesread>0) {
					serverlist[bytesread]=0;
					listread=true;
				}
		}
		CloseHandle(tempfile);
	}
	if (listread) {
		char* pitem=strtok(serverlist,"\r");
		while(pitem) {
			if (pitem[0]=='\n')
				pitem++;
			if (pitem[0]!='#') {  // a comment
				char* pitemend=strchr(pitem,',');
				if (pitemend) {
					pitemend[0]=0;
					if (strcmp(pitem,servertype)==0) { //found!!!
						pitem=mystrtok(pitemend+1,',');
						if (pitem) {      // Server Adresse
							if (pitem[0] && changeserverfield)
								SetDlgItemText(hWnd,IDC_CONNECTTO,pitem);
							pitem=mystrtok(NULL,',');
						}
						if (pitem) {      // SSL
							if (pitem[0])
							{
								CheckDlgButton(hWnd,IDC_SECURE_SSL,pitem[0]=='1' ? BST_CHECKED : BST_UNCHECKED);
								EnableWindow(GetDlgItem(hWnd,IDC_CBO_CC), pitem[0]=='1');
							}
							else
								EnableWindow(GetDlgItem(hWnd,IDC_CBO_CC), FALSE);

							pitem=mystrtok(NULL,',');
						}
						if (pitem) {      // UTF8 Codierung
							if (pitem[0])
								CheckDlgButton(hWnd,IDC_UTF8_DIRS,pitem[0]=='1' ? BST_CHECKED : BST_UNCHECKED);
							pitem=mystrtok(NULL,',');
						}
						if (pitem) {      // 3Step
							if (pitem[0]) {
								if (pitem[0]=='2') {
									CheckDlgButton(hWnd,IDC_MULTISTEP,BST_UNCHECKED);
									EnableWindow(GetDlgItem(hWnd,IDC_3STEP_UPLOAD),false);
								} else {
									EnableWindow(GetDlgItem(hWnd,IDC_3STEP_UPLOAD),true);
									CheckDlgButton(hWnd,IDC_MULTISTEP,BST_CHECKED);
									CheckDlgButton(hWnd,IDC_3STEP_UPLOAD,pitem[0]=='1' ? BST_CHECKED : BST_UNCHECKED);
								}
							}
							pitem=mystrtok(NULL,',');
						}
						if (pitem) {      // Delete
							if (pitem[0])
								CheckDlgButton(hWnd,IDC_DELETE_BEFORE_UPLOAD,pitem[0]=='1' ? BST_CHECKED : BST_UNCHECKED);
							pitem=mystrtok(NULL,',');
						}
						if (pitem) {      // ApacheDirWithSlash
							if (pitem[0])
								CheckDlgButton(hWnd,IDC_APACHE_DIR_WITH_SLASH,pitem[0]=='1' ? BST_CHECKED : BST_UNCHECKED);
							pitem=mystrtok(NULL,',');
						}
						break;
					}
				}
			}
			pitem=strtok(NULL,"\r");
		}
	}
	if (size)
		free(serverlist);
}

void WebDavGetRelativePath(void* serverid,char* RelativePath,int maxlen)
{
	pConnectSettings ConnectSettings=(pConnectSettings)serverid;
	strlcpy(RelativePath,ConnectSettings->rootdir,maxlen);
}

pConnectSettings gConnectResults;
char* gDisplayName;
char* gIniFileName;

int g_focusset=0;

// SR: 09.07.2005


LPCTSTR g_pszKey = _T("unpzScGeCInX7XcRM2z+svTK+gegRLhz9KXVbYKJl5boSvVCcfym");

void EncryptString(LPCTSTR pszPlain, LPTSTR pszEncrypted, UINT cchEncrypted)
{
	int iPlainLength = lstrlen(pszPlain);
	int iKeyLength = lstrlen(g_pszKey);
	int iPos = lstrlen(pszPlain) % iKeyLength;

	pszEncrypted[0] = _TCHAR('\0');
	
	for (int iChar = 0; iChar < iPlainLength; iChar++)
	{
		sprintf(pszEncrypted, _T("%s%03d"), pszEncrypted, pszPlain[iChar] ^ g_pszKey[(iChar + iPos) % iKeyLength]);
	}
}

void DecryptString(LPCTSTR pszEncrypted, LPTSTR pszPlain, UINT cchPlain)
{
	int iKeyLength = lstrlen(g_pszKey);
	int iEncryptedLength = lstrlen(pszEncrypted);
	int iPos = (iEncryptedLength/3) % iKeyLength;

	pszPlain[0] = _TCHAR('\0');

	for (int iChar = 0; iChar < iEncryptedLength / 3 && iChar < (int) (cchPlain - 1); iChar++)
	{
		int iDigit = pszEncrypted[iChar * 3];
		if (iDigit < '0' || iDigit > '9')
		{
			pszPlain[0] = _TCHAR('\0');
			return;
		}

		int iNumber = (iDigit - '0') * 100;
		iDigit = pszEncrypted[iChar * 3 + 1];
		if (iDigit < '0' || iDigit > '9')
		{
			pszPlain[0] = _TCHAR('\0');
			return;
		}
		
		iNumber += (iDigit - '0') * 10;
		iDigit = pszEncrypted[iChar * 3 + 2];
		if (iDigit < '0' || iDigit > '9')
		{
			pszPlain[0] = _TCHAR('\0');
			return;
		}
		
		iNumber += iDigit - '0';
		pszPlain[iChar] = _TCHAR(iNumber ^ g_pszKey[(iChar + iPos) % iKeyLength]);
	}

	pszPlain[iChar] = _TCHAR('\0');
}

BOOL LoadServerSettings(char* DisplayName,pConnectSettings ConnectResults)
{
	char szPassword[MAX_PATH];
	GetPrivateProfileString(DisplayName,"server","",ConnectResults->server,sizeof(ConnectResults->server)-1,gIniFileName);
	GetPrivateProfileString(DisplayName,"user","",ConnectResults->user,sizeof(ConnectResults->user)-1,gIniFileName);
	ConnectResults->SslConnect=GetPrivateProfileInt(gDisplayName,"ssl",0,gIniFileName)!=0;
	if (ConnectResults->SslConnect)
		ConnectResults->SslFlags=INTERNET_FLAG_SECURE | INTERNET_FLAG_RELOAD; // | INTERNET_FLAG_IGNORE_CERT_CN_INVALID;
	else
		ConnectResults->SslFlags=0;

	GetPrivateProfileString(DisplayName,"ssl_cert_issuer","",ConnectResults->SslCertIssuer,sizeof(ConnectResults->SslCertIssuer)-1,gIniFileName);
	GetPrivateProfileString(DisplayName,"ssl_cert_serial","",ConnectResults->SslCertSerial,sizeof(ConnectResults->SslCertSerial)-1,gIniFileName);

	ConnectResults->interpreturlasutf8=GetPrivateProfileInt(gDisplayName,"utf8urls",0,gIniFileName)!=0;
	ConnectResults->use3stepuploadmethod=GetPrivateProfileInt(gDisplayName,"3stepupload",0,gIniFileName)!=0;
	ConnectResults->usemultistepuploadmethod=GetPrivateProfileInt(gDisplayName,"multistepupload",1,gIniFileName)!=0;
	ConnectResults->deletebeforeupload=GetPrivateProfileInt(gDisplayName,"deletebeforeupload",0,gIniFileName)!=0;
	ConnectResults->detailedlog=GetPrivateProfileInt(gDisplayName,"detailedlog",0,gIniFileName)!=0;
	ConnectResults->apacheDirWithSlash=GetPrivateProfileInt(gDisplayName,"apacheDirWithSlash",0,gIniFileName)!=0;
	ConnectResults->password[0]=0;
	if (GetPrivateProfileString(gDisplayName,"password","", szPassword, countof(szPassword), gIniFileName))
	{
		DecryptString(szPassword, ConnectResults->password, countof(ConnectResults->password));
	}
	ConnectResults->proxytype=GetPrivateProfileInt("proxy","proxytype",1,gIniFileName);
	GetPrivateProfileString("proxy","proxyserver","",ConnectResults->proxyserver,sizeof(ConnectResults->proxyuser)-1,gIniFileName);
	GetPrivateProfileString("proxy","proxyuser","",ConnectResults->proxyuser,sizeof(ConnectResults->proxyuser)-1,gIniFileName);
	if (GetPrivateProfileString("proxy","proxypassword","", szPassword, countof(szPassword), gIniFileName))
	{
		DecryptString(szPassword, ConnectResults->proxypassword,countof(ConnectResults->proxypassword));
	}
	return ConnectResults->server[0]!=0;
}

// SR: 09.07.2005


int __stdcall ConnectDlgProc(HWND hWnd,unsigned int Message,WPARAM wParam,LPARAM lParam)
{
	RECT rt1,rt2;
	int w,h,DlgWidth,DlgHeight,NewPosX,NewPosY;

	switch (Message) {
	case WM_INITDIALOG: {
		FillServerList(hWnd);
		SendDlgItemMessage(hWnd,IDC_DEFAULTCOMBO,CB_SETCURSEL,0,0);
		FillClientCertList(hWnd, gConnectResults);
		serverfieldchangedbyuser=false;
		if (strcmp(gDisplayName,s_quickconnect)!=0) {
			SetDlgItemText(hWnd,IDC_CONNECTTO,gConnectResults->server);
			if (gConnectResults->server[0])
				serverfieldchangedbyuser=true;

			SetDlgItemText(hWnd,IDC_USERNAME,gConnectResults->user);

			if (gConnectResults->SslConnect)
			{
				CheckDlgButton(hWnd,IDC_SECURE_SSL,BST_CHECKED);
				EnableWindow(GetDlgItem(hWnd,IDC_CBO_CC), TRUE);
			}
			else
				EnableWindow(GetDlgItem(hWnd,IDC_CBO_CC), FALSE);

			if (gConnectResults->interpreturlasutf8)
				CheckDlgButton(hWnd,IDC_UTF8_DIRS,BST_CHECKED);
			
			if (gConnectResults->use3stepuploadmethod)
				CheckDlgButton(hWnd,IDC_3STEP_UPLOAD,BST_CHECKED);

			if (gConnectResults->usemultistepuploadmethod)
				CheckDlgButton(hWnd,IDC_MULTISTEP,BST_CHECKED);
			else
				EnableWindow(GetDlgItem(hWnd,IDC_3STEP_UPLOAD),false);

			if (gConnectResults->deletebeforeupload)
				CheckDlgButton(hWnd,IDC_DELETE_BEFORE_UPLOAD,BST_CHECKED);

			if (gConnectResults->detailedlog)
				CheckDlgButton(hWnd,IDC_DETAILED_LOG,BST_CHECKED);

			if (gConnectResults->apacheDirWithSlash)
				CheckDlgButton(hWnd,IDC_APACHE_DIR_WITH_SLASH,BST_CHECKED);
			SetDlgItemText(hWnd,IDC_PASSWORD, gConnectResults->password);
			switch (gConnectResults->proxytype) {
			case 0:CheckRadioButton(hWnd,IDC_IEPROXY,IDC_OTHERPROXY,IDC_NOPROXY);break;
			case 2:CheckRadioButton(hWnd,IDC_IEPROXY,IDC_OTHERPROXY,IDC_OTHERPROXY);break;
			default:
				CheckRadioButton(hWnd,IDC_IEPROXY,IDC_OTHERPROXY,IDC_IEPROXY);
			}
			EnableWindow(GetDlgItem(hWnd,IDC_PROXYSERVER),gConnectResults->proxytype==2);
			EnableWindow(GetDlgItem(hWnd,IDC_PROXYUSERNAME),gConnectResults->proxytype!=0);
			EnableWindow(GetDlgItem(hWnd,IDC_PROXYPASSWORD),gConnectResults->proxytype!=0);
			SetDlgItemText(hWnd,IDC_PROXYSERVER,gConnectResults->proxyserver);
			SetDlgItemText(hWnd,IDC_PROXYUSERNAME,gConnectResults->proxyuser);
			SetDlgItemText(hWnd,IDC_PROXYPASSWORD, gConnectResults->proxypassword);
		}

		if (strcmp(gDisplayName,s_quickconnect)!=0) {
			if (gConnectResults->server[0]==0)
				g_focusset=IDC_CONNECTTO;
			else if (gConnectResults->user[0]==0)
				g_focusset=IDC_USERNAME;
			else
				g_focusset=IDC_PASSWORD;
		} else
			g_focusset=IDC_CONNECTTO;

		// trying to center the About dialog
		if (GetWindowRect(hWnd, &rt1) && GetWindowRect(GetParent(hWnd), &rt2)) {
			w=rt2.right-rt2.left;
			h=rt2.bottom-rt2.top;
			DlgWidth   = rt1.right - rt1.left;
			DlgHeight   = rt1.bottom - rt1.top ;
			NewPosX      =rt2.left + (w - DlgWidth)/2;
			NewPosY      =rt2.top + (h - DlgHeight)/2;
			SetWindowPos(hWnd, 0, NewPosX, NewPosY,
				0, 0, SWP_NOZORDER | SWP_NOSIZE);
		}

		// SR: 11.07.2005
		serverfieldchangedbyuser=false;

		return 1;
		break;
	}
	case WM_SHOWWINDOW: {
		if (g_focusset)
			SetFocus(GetDlgItem(hWnd,g_focusset));
		break;
	}
	case WM_COMMAND: {
		switch(LOWORD(wParam)) {
			case IDOK: {
				GetDlgItemText(hWnd,IDC_CONNECTTO,gConnectResults->server,sizeof(gConnectResults->server)-1);
				GetDlgItemText(hWnd,IDC_USERNAME,gConnectResults->user,sizeof(gConnectResults->user)-1);
				GetDlgItemText(hWnd,IDC_PASSWORD,gConnectResults->password,sizeof(gConnectResults->password)-1);
				gConnectResults->SslConnect=IsDlgButtonChecked(hWnd,IDC_SECURE_SSL);
				gConnectResults->interpreturlasutf8=IsDlgButtonChecked(hWnd,IDC_UTF8_DIRS);
				gConnectResults->use3stepuploadmethod=IsDlgButtonChecked(hWnd,IDC_3STEP_UPLOAD);
				gConnectResults->usemultistepuploadmethod=IsDlgButtonChecked(hWnd,IDC_MULTISTEP);
				gConnectResults->deletebeforeupload=IsDlgButtonChecked(hWnd,IDC_DELETE_BEFORE_UPLOAD);
				gConnectResults->detailedlog=IsDlgButtonChecked(hWnd,IDC_DETAILED_LOG);
				gConnectResults->apacheDirWithSlash=IsDlgButtonChecked(hWnd,IDC_APACHE_DIR_WITH_SLASH);

				if (IsDlgButtonChecked(hWnd,IDC_NOPROXY))
					gConnectResults->proxytype=0;
				else if (IsDlgButtonChecked(hWnd,IDC_OTHERPROXY))
					gConnectResults->proxytype=2;
				else
					gConnectResults->proxytype=1;

				GetDlgItemText(hWnd,IDC_PROXYSERVER,gConnectResults->proxyserver,sizeof(gConnectResults->proxyserver)-1);
				GetDlgItemText(hWnd,IDC_PROXYUSERNAME,gConnectResults->proxyuser,sizeof(gConnectResults->proxyuser)-1);
				GetDlgItemText(hWnd,IDC_PROXYPASSWORD,gConnectResults->proxypassword,sizeof(gConnectResults->proxypassword)-1);
				if (strcmp(gDisplayName,s_quickconnect)!=0) {
					WritePrivateProfileString(gDisplayName,"server",gConnectResults->server,gIniFileName);
					WritePrivateProfileString(gDisplayName,"user",gConnectResults->user,gIniFileName);
					WritePrivateProfileString(gDisplayName,"ssl",gConnectResults->SslConnect ? "1" : NULL,gIniFileName);
					WritePrivateProfileString(gDisplayName,"utf8urls",gConnectResults->interpreturlasutf8 ? "1" : NULL,gIniFileName);
					WritePrivateProfileString(gDisplayName,"3stepupload",gConnectResults->use3stepuploadmethod ? "1" : NULL,gIniFileName);
					WritePrivateProfileString(gDisplayName,"multistepupload",gConnectResults->usemultistepuploadmethod ? NULL : "0",gIniFileName);
					WritePrivateProfileString(gDisplayName,"deletebeforeupload",gConnectResults->deletebeforeupload ? "1" : NULL,gIniFileName);
					WritePrivateProfileString(gDisplayName,"detailedlog",gConnectResults->detailedlog ? "1" : NULL,gIniFileName);
					WritePrivateProfileString(gDisplayName,"apacheDirWithSlash",gConnectResults->apacheDirWithSlash ? "1" : NULL,gIniFileName);

					WritePrivateProfileString("proxy","proxyserver",gConnectResults->proxyserver,gIniFileName);
					WritePrivateProfileString("proxy","proxyuser",gConnectResults->proxyuser,gIniFileName);
					char buf[16];
					itoa(gConnectResults->proxytype,buf,10);
					WritePrivateProfileString("proxy","proxytype",gConnectResults->proxytype!=1 ? buf : NULL,gIniFileName);

					// SR: 09.07.2005
					if (!gConnectResults->dialogforconnection)
					{
						TCHAR szEncryptedPassword[MAX_PATH]; EncryptString(gConnectResults->password, szEncryptedPassword, countof(szEncryptedPassword));
						WritePrivateProfileString(gDisplayName,"password",szEncryptedPassword,gIniFileName);

						EncryptString(gConnectResults->proxypassword, szEncryptedPassword, countof(szEncryptedPassword));
						WritePrivateProfileString("proxy","proxypassword",szEncryptedPassword,gIniFileName);
					}

					// save the client cert info...
					if (IsDlgButtonChecked(hWnd,IDC_SECURE_SSL))
					{
						int iSel = SendDlgItemMessage(hWnd, IDC_CBO_CC, CB_GETCURSEL, (WPARAM) 0, (LPARAM) 0);

						if (iSel > -1)
						{
							if (iSel == 0)
							{
								// first item selected -> empty item so remove the cert infos from ini
								WritePrivateProfileString(gDisplayName,"ssl_cert_issuer", NULL, gIniFileName);
								WritePrivateProfileString(gDisplayName,"ssl_cert_serial", NULL, gIniFileName);
							}
							else
							{
								CRYPT_INTEGER_BLOB* clbSerialB64 = reinterpret_cast<CRYPT_INTEGER_BLOB*>(SendDlgItemMessage(hWnd, IDC_CBO_CC, CB_GETITEMDATA, (WPARAM) iSel, (LPARAM) 0));

								if (clbSerialB64 != NULL)
								{
									BYTE* pbSerial = (BYTE*) malloc(clbSerialB64->cbData + 1);
									char* pszIssuer = (char*) malloc(SendDlgItemMessage(hWnd, IDC_CBO_CC, CB_GETLBTEXTLEN, (WPARAM) iSel, (LPARAM) 0) + 1); // + 1 due to null char

									if (pszIssuer)
									{
										if (SendDlgItemMessage(hWnd, IDC_CBO_CC, CB_GETLBTEXT, (WPARAM) iSel, (LPARAM) pszIssuer) > 0)
											WritePrivateProfileString(gDisplayName,"ssl_cert_issuer", pszIssuer, gIniFileName);

										free(pszIssuer);
										pszIssuer = NULL;

										if (pbSerial)
										{
											memcpy(pbSerial, clbSerialB64->pbData, clbSerialB64->cbData);
											pbSerial[clbSerialB64->cbData] = '\0';

											WritePrivateProfileString(gDisplayName,"ssl_cert_serial", (const char*) pbSerial, gIniFileName);
										}
									}

									if (pbSerial)
									{
										free(pbSerial);
										pbSerial = NULL;
									}
								}
							}
						}
					}
					else
					{
						// no item selected -> remove the cert infos from ini
						WritePrivateProfileString(gDisplayName,"ssl_cert_issuer", NULL, gIniFileName);
						WritePrivateProfileString(gDisplayName,"ssl_cert_serial", NULL, gIniFileName);
					}
				}
				else
				{
					// get client cert info for the quick connection ...
					if (IsDlgButtonChecked(hWnd,IDC_SECURE_SSL))
					{
						int iSel = SendDlgItemMessage(hWnd, IDC_CBO_CC, CB_GETCURSEL, (WPARAM) 0, (LPARAM) 0);

						if (iSel > 0)
						{
							CRYPT_INTEGER_BLOB* clbSerialB64 = reinterpret_cast<CRYPT_INTEGER_BLOB*>(SendDlgItemMessage(hWnd, IDC_CBO_CC, CB_GETITEMDATA, (WPARAM) iSel, (LPARAM) 0));

							if (clbSerialB64 != NULL)
							{
								BYTE* pbSerial = (BYTE*) malloc(clbSerialB64->cbData + 1);
								char* pszIssuer = (char*) malloc(SendDlgItemMessage(hWnd, IDC_CBO_CC, CB_GETLBTEXTLEN, (WPARAM) iSel, (LPARAM) 0) + 1); // + 1 due to null char

								if (pszIssuer)
								{
									if (SendDlgItemMessage(hWnd, IDC_CBO_CC, CB_GETLBTEXT, (WPARAM) iSel, (LPARAM) pszIssuer) > 0)
										strcpy(gConnectResults->SslCertIssuer, pszIssuer);

									free(pszIssuer);
									pszIssuer = NULL;

									if (pbSerial)
									{
										memcpy(pbSerial, clbSerialB64->pbData, clbSerialB64->cbData);
										pbSerial[clbSerialB64->cbData] = '\0';

										strcpy(gConnectResults->SslCertSerial, (const char*) pbSerial);
									}
								}

								if (pbSerial)
								{
									free(pbSerial);
									pbSerial = NULL;
								}
							}
						}
					}
				}

				if (gConnectResults->SslConnect)
					gConnectResults->SslFlags=INTERNET_FLAG_SECURE | INTERNET_FLAG_RELOAD; // | INTERNET_FLAG_IGNORE_CERT_CN_INVALID;
				else
					gConnectResults->SslFlags=0;
				gConnectResults->customport=0;  // will be set later

				// free serial number structures associated with each client certificate combo item
				int iCount = SendDlgItemMessage(hWnd, IDC_CBO_CC, CB_GETCOUNT, (WPARAM) 0, (LPARAM) 0);

				for (int i = 0; i < iCount; i++)
				{
					CRYPT_INTEGER_BLOB* clbSerialB64 = reinterpret_cast<CRYPT_INTEGER_BLOB*>(SendDlgItemMessage(hWnd, IDC_CBO_CC, CB_GETITEMDATA, (WPARAM) i, (LPARAM) 0));

					if (clbSerialB64 != NULL)
					{
						delete clbSerialB64;
						clbSerialB64 = NULL;
					}
				}

				EndDialog(hWnd, IDOK);
				return 1;
			}
			case IDCANCEL:
			{
				// free serial number structures associated with each client certificate combo item
				int iCount = SendDlgItemMessage(hWnd, IDC_CBO_CC, CB_GETCOUNT, (WPARAM) 0, (LPARAM) 0);

				for (int i = 0; i < iCount; i++)
				{
					CRYPT_INTEGER_BLOB* clbSerialB64 = reinterpret_cast<CRYPT_INTEGER_BLOB*>(SendDlgItemMessage(hWnd, IDC_CBO_CC, CB_GETITEMDATA, (WPARAM) i, (LPARAM) 0));

					if (clbSerialB64 != NULL)
					{
						delete clbSerialB64;
						clbSerialB64 = NULL;
					}
				}

				EndDialog(hWnd, IDCANCEL);
				return 1;
			}
			case IDC_CONNECTTO:
				if (HIWORD(wParam)==EN_CHANGE) {
					serverfieldchangedbyuser=true;
				}
				break;
			case IDC_IEPROXY:
				EnableWindow(GetDlgItem(hWnd,IDC_PROXYSERVER),false);
				EnableWindow(GetDlgItem(hWnd,IDC_PROXYUSERNAME),true);
				EnableWindow(GetDlgItem(hWnd,IDC_PROXYPASSWORD),true);
				break;
			case IDC_OTHERPROXY:
				EnableWindow(GetDlgItem(hWnd,IDC_PROXYSERVER),true);
				EnableWindow(GetDlgItem(hWnd,IDC_PROXYUSERNAME),true);
				EnableWindow(GetDlgItem(hWnd,IDC_PROXYPASSWORD),true);
				SetFocus(GetDlgItem(hWnd, IDC_PROXYSERVER));
				break;
			case IDC_NOPROXY:
				EnableWindow(GetDlgItem(hWnd,IDC_PROXYSERVER),false);
				EnableWindow(GetDlgItem(hWnd,IDC_PROXYUSERNAME),false);
				EnableWindow(GetDlgItem(hWnd,IDC_PROXYPASSWORD),false);
				break;
			case IDC_MULTISTEP:
				EnableWindow(GetDlgItem(hWnd,IDC_3STEP_UPLOAD),IsDlgButtonChecked(hWnd,IDC_MULTISTEP));
				break;
			case IDC_DEFAULTCOMBO: {
				if (HIWORD(wParam)==CBN_SELCHANGE) {
					char servertype[MAX_PATH];
					BOOL oldserverfieldchangedbyuser=serverfieldchangedbyuser;
					int id=SendDlgItemMessage(hWnd,IDC_DEFAULTCOMBO,CB_GETCURSEL,0,0);
					if (id!=CB_ERR) {
						SendDlgItemMessage(hWnd,IDC_DEFAULTCOMBO,CB_GETLBTEXT,id,(LPARAM)&servertype);
						if (servertype[0]) {
							// multi-step is always the default
							LoadServerSettingsFromList(hWnd,servertype,!serverfieldchangedbyuser);
							// restore change flag
							serverfieldchangedbyuser=oldserverfieldchangedbyuser;
						}
					}
				}
				break;
			}
			case IDC_MULTISTEPHELP:
				TCHAR szCaption[100]; LoadString(hinst, IDS_HELP_CAPTION, szCaption, countof(szCaption));
				TCHAR szBuffer[1024]; LoadString(hinst, IDS_HELP_MULTISTEPUPLOAD, szBuffer, countof(szBuffer));
				MessageBox(hWnd, szBuffer, szCaption, MB_OK | MB_ICONINFORMATION);
				break;
			case IDC_3STEPHELP: 
			{
				// SR: 10.07.2005
				TCHAR szCaption[100]; LoadString(hinst, IDS_HELP_CAPTION, szCaption, countof(szCaption));
				TCHAR szBuffer[1024]; LoadString(hinst, IDS_HELP_THREESTEPUPLOAD, szBuffer, countof(szBuffer));
//				MessageBox(hWnd,"Normally the WebDAV plugin uses a two step upload method:\nFirst, a 1 byte file is sent to allow server authentication, and to avoid a lengthy big file upload which then fails with an 'access denied' error.\nIf this went OK, the actual file is sent.\n\nMicrosoft IIS requires a 3 step upload for NT LanMan authentication, though, so this option needs to be checked for IIS.","Help",MB_OK | MB_ICONINFORMATION);
				MessageBox(hWnd, szBuffer, szCaption, MB_OK | MB_ICONINFORMATION);
				break;
			}
			case IDC_UTF8HELP: 
			{
				// SR: 10.07.2005
				TCHAR szCaption[100]; LoadString(hinst, IDS_HELP_CAPTION, szCaption, countof(szCaption));
				TCHAR szBuffer[1024]; LoadString(hinst, IDS_HELP_UTF8, szBuffer, countof(szBuffer));
//				MessageBox(hWnd,"Some WebDAV servers expect accents and umlauts like  as plain text (ANSI), others as Unicode UTF-8.\nIf in doubt, try plain text first, and if the uploaded accents appear as garbage, use UTF-8.\n\nIf you have local access to the server, you may have a look at the created file names in both cases.","Help",MB_OK | MB_ICONINFORMATION);
				MessageBox(hWnd, szBuffer, szCaption, MB_OK | MB_ICONINFORMATION);
				break;
			}
			case IDC_DELUPLHELP: 
			{
				// SR: 10.07.2005
				TCHAR szCaption[100]; LoadString(hinst, IDS_HELP_CAPTION, szCaption, countof(szCaption));
				TCHAR szBuffer[1024]; LoadString(hinst, IDS_HELP_DELETEBEFOREUPLOAD, szBuffer, countof(szBuffer));
//				MessageBox(hWnd,"On some servers, upload fails when a file with the same name already exists. With this option, the remote file is deleted before the new file is uploaded. On other servers, this has the effect that the deleted file is sent to the server's recycle bin.","Help",MB_OK | MB_ICONINFORMATION);
				MessageBox(hWnd, szBuffer, szCaption, MB_OK | MB_ICONINFORMATION);
				break;
			}
			case IDC_PROXYHELP: 
			{
				TCHAR szCaption[100]; LoadString(hinst, IDS_HELP_CAPTION, szCaption, countof(szCaption));
				TCHAR szBuffer[1024]; LoadString(hinst, IDS_HELP_PROXY, szBuffer, countof(szBuffer));
				MessageBox(hWnd, szBuffer, szCaption, MB_OK | MB_ICONINFORMATION);
				break;
			}
			case IDC_SECURE_SSL:
			{
				BOOL bChecked = IsDlgButtonChecked(hWnd,IDC_SECURE_SSL);
				EnableWindow(GetDlgItem(hWnd,IDC_CBO_CC), bChecked);
			}
		}
	}
	}
	return 0;
}

BOOL ShowConnectDialog(pConnectSettings ConnectSettings,char* DisplayName,char* inifilename)
{
	gConnectResults=ConnectSettings;
	gDisplayName=DisplayName;
	gIniFileName=inifilename;
	LoadServerSettings(DisplayName,ConnectSettings);
	if (ConnectSettings->dialogforconnection &&    // don't show dialog if:
	    ConnectSettings->password[0] &&            // password saved
		(ConnectSettings->proxyuser[0]==0 ||       // no proxy auth required
		 ConnectSettings->proxypassword[0]))       //  or proxy pass saved
		return true;
	else
		return (IDOK==DialogBox(hinst,MAKEINTRESOURCE(IDD_WEBDAV),GetActiveWindow(),ConnectDlgProc));
}

BOOL WebDavConfigureServer(char* DisplayName,char* inifilename)
{
	tConnectSettings ConnectSettings;

	memset(&ConnectSettings,0,sizeof(tConnectSettings));
	ConnectSettings.dialogforconnection=false;
	ConnectSettings.SslCertStore = NULL;
 	return ShowConnectDialog(&ConnectSettings,DisplayName,inifilename);
}

void* WebDavConnectToServer(char* DisplayName,char* inifilename)
{
	tConnectSettings ConnectSettings;

	memset(&ConnectSettings,0,sizeof(tConnectSettings));
	ConnectSettings.SslCertStore = NULL;
	ConnectSettings.dialogforconnection=true;
 	
	// Get connection settings here
	if (ShowConnectDialog(&ConnectSettings,DisplayName,inifilename)) {
		// Clear proxy user and pass if proxy type is set to 0!
		if (ConnectSettings.proxytype==0) {
			ConnectSettings.proxyuser[0]=0;
			ConnectSettings.proxypassword[0]=0;
		}
		// split server name into server/path
		ReplaceBackslashBySlash(ConnectSettings.server);
		// Remove trailing http://
		if (strnicmp(ConnectSettings.server,"http://",7)==0)
			memmove(ConnectSettings.server,ConnectSettings.server+7,strlen(ConnectSettings.server)-6);
		else if (strnicmp(ConnectSettings.server,"https://",8)==0)
			memmove(ConnectSettings.server,ConnectSettings.server+8,strlen(ConnectSettings.server)-7);
		char* p=strchr(ConnectSettings.server,'/');
		if (p) {
			strlcpy(ConnectSettings.rootdir,p,sizeof(ConnectSettings.rootdir)-1);
			p[0]=0;
			// remove trailing backslash, also in case of root!
			p=strrchr(ConnectSettings.rootdir,'/');
			if (p && p[1]==0)
				p[0]=0;
		} else
			ConnectSettings.rootdir[0]=0;
		// look for custom port
		p=strchr(ConnectSettings.server,':');
		if (p) {
			p[0]=0;
			p++;
			ConnectSettings.customport=atoi(p);
		} else if (ConnectSettings.SslConnect)
			ConnectSettings.customport=INTERNET_DEFAULT_HTTPS_PORT;
		if (ProgressProc(PluginNumber,DisplayName,"temp",0))
			return NULL;
		if (WebDavConnect(&ConnectSettings)!=DAV_OK)
			return NULL;
		{
			char connbuf[MAX_PATH];
			strcpy(connbuf,"CONNECT \\");
			strlcat(connbuf,DisplayName,sizeof(connbuf)-1);
			LogProc(PluginNumber,MSGTYPE_CONNECT,connbuf);
			pConnectSettings psettings=(pConnectSettings)malloc(sizeof(ConnectSettings));
			memcpy(psettings,&ConnectSettings,sizeof(ConnectSettings));
			return psettings;
		}
	}
	return NULL;
}

int WebDavCloseConnection(void* serverid)
{
	pConnectSettings ConnectSettings=(pConnectSettings)serverid;

	// delete temp file
	if (ConnectSettings->TempPathUniqueValue) {
		char buffer[MAX_PATH];
		char tempfilename[MAX_PATH];
		GetTempPath(MAX_PATH,buffer);
		GetTempFileName(buffer,"DAV",ConnectSettings->TempPathUniqueValue,tempfilename);
		if (tempfilename[0]) {
			DeleteFile(tempfilename);
		}
		ConnectSettings->TempPathUniqueValue=0;
	}

	if (ConnectSettings->ConnHandle) {
		ShowStatus("Disconnected");
		InternetCloseHandle(ConnectSettings->ConnHandle);
		ConnectSettings->ConnHandle=NULL;
		numconnections--;
	}
	if (ConnectSettings->InetHandle) {
		InternetCloseHandle(ConnectSettings->InetHandle);
		ConnectSettings->InetHandle=NULL;
	}
	if (numconnections<=0) {
		WSACleanup();
		numconnections=0;
	}
	ConnectSettings->servernamelen=0;

	return DAV_OK;
}

const char* skip_n_slashes(const char* p,int slashcount)
{
	while (slashcount && p[0]) {
		if (p[0]=='/') {
			slashcount--;
			if (slashcount==0)
				return p+1;
		}
		p++;
	}
	if (p[0]=='/')
		p++;
	return p; // points to ending 0 if too many slashes
}

int getslashcount(char* p) // subdir like this //subdir
{
	int slashcount=0;
	while (p[0]) {
		if (p[0]=='/' && p[1]!=0)  // don't count railing slash!
			slashcount++;
		p++;
	}
	return slashcount;	
}

int dav_readdir(DAV_OPENDIR_DATA *oddata)
{
	DAV_ACTIVELOCK *activelock = NULL;
	if(oddata == NULL) 
	{
		return FALSE;
	}
	if(oddata->response_cursor == NULL)
	{
		return FALSE;
	}
	if(oddata->response_cursor->href == NULL)
	{
		return FALSE;
	}
	oddata->href = oddata->response_cursor->href;
	oddata->prop = dav_find_prop(oddata->response_cursor, 200, 200);
	oddata->response_cursor = oddata->response_cursor->next_response;

	strlcpy(oddata->namebuf,oddata->href,sizeof(oddata->namebuf)-1);


	// The following conversion is necessary for the special case
	// Where the message body is sent as UTF-8, BUT encoded as quoted-printable!
	// File names can be sent in two ways:
	// 1. name%e4.txt , where %e4 ->  (not Unicode!) -> no conversion! Example: GMX: %e4%f6%fc.bat -> .bat
	// 2. name%ab%cd.txt, where %ab%cd ->  (Unicode!) -> conversion needed here!
	// 3. name??.txt, where ?? ->  (Unicode!) -> conversion needed here!
	// The user has two options: a) Send/Receive as UTF8 b) not
	// In case a, the name is sent as %ab%cd, in case b as %e4
	// For receiving:
	// a) convert after % decoding => oddata->interpreturlasutf8
	// b) convert BEFORE % decoding, but only if header or body is marked as UTF-8!
	if (oddata->interpreturlasutf8) {
		WCHAR utf16buf[1024];
		unsigned char* srcstart=(unsigned char*)oddata->namebuf;
		WCHAR* trgstart=utf16buf;
		ConvertUTF8toUTF16(&srcstart,(unsigned char*)oddata->namebuf+strlen(oddata->namebuf)+1,
			&trgstart,utf16buf+sizeof(utf16buf)-1);
		WideCharToMultiByte(CP_ACP,0,utf16buf,-1,oddata->namebuf,sizeof(oddata->namebuf)-1,NULL,NULL);
	}
	const char* p;
	if (oddata->namebuf[0]=='/') {   // dir relative to server
		p=oddata->namebuf+1;  // firstt char after initial slash
		p=skip_n_slashes(p,oddata->directory_slash_count);
		if(p[0]==0)
		{
			return dav_readdir(oddata);
		}
	} else {
		p=oddata->namebuf;
		// now skip the server name and if present also the port number:
		// http[s]://server.com[:80]/path_name/filename
		// first skip http or https
		if (strnicmp(p,"https://",8)==0)
			p+=8;
		else
			p+=7;
		while (p[0] && p[0]!='/') // skip the server
			p++;
		if (p[0]=='/')  // skip first slash after server name
			p++;
		p=skip_n_slashes(p,oddata->directory_slash_count); //skip path

		if(p[0]==0)  //it's the dir itself
		{
			return dav_readdir(oddata);
		}
	}
	oddata->filename = p;

	if(oddata->prop != NULL)
	{
		oddata->size = oddata->prop->getcontentlength;
		oddata->cdate = oddata->prop->creationdate;
		oddata->mdate = oddata->prop->getlastmodified;
		oddata->type = oddata->prop->resourcetype;
		if((activelock = dav_find_activelock(oddata->prop, DAV_LOCKSCOPE_EXCLUSIVE, DAV_LOCKTYPE_WRITE)) != NULL)
		{
			oddata->lockowner = activelock->owner;
		}
		else
		{
			oddata->lockowner = NULL;
		}
	}
	return TRUE;
}

void dav_closedir(DAV_OPENDIR_DATA *oddata)
{
	if(oddata != NULL) 
	{
		dav_multistatus_destroy(&oddata->multistatus);
	}
}

int GetStatusCode(HINTERNET HttpHandle)
{
	char StatusCode[8];
	DWORD len=sizeof(StatusCode)-1;
	DWORD idx=0;
  	if (!HttpQueryInfo(HttpHandle, HTTP_QUERY_STATUS_CODE, &StatusCode, &len, &idx))
		strcpy(StatusCode,"400");
	return atoi(StatusCode);
}

int GetStatusAndShowError(HINTERNET HttpHandle,BOOL detailedlog)
{
	char StatusCode[8];
	DWORD len=sizeof(StatusCode)-1;
	DWORD idx=0;

	// Debug: Show headers 
	{
		char buffer[8192];
		DWORD len=sizeof(buffer)-1;
		DWORD idx=0;
		if (HttpQueryInfo(HttpHandle,HTTP_QUERY_FLAG_REQUEST_HEADERS | HTTP_QUERY_RAW_HEADERS, buffer, &len, &idx)) {
			ShowStatus(buffer); // the request
			if (detailedlog) {
				char* p=buffer+strlen(buffer);
				char* p1=p+1;  // skip http line
				while (p[1]) {
					p[0]='\n';
					p=buffer+strlen(buffer);
				}
				ShowStatus(p1); // the additional headers
			}
		}
		if (detailedlog) {
			ShowStatus("******Received headers");
			len=sizeof(buffer)-1;
			if (HttpQueryInfo(HttpHandle,HTTP_QUERY_RAW_HEADERS, buffer, &len, &idx)) {
				ShowStatus(buffer); // the request
				char* p=buffer+strlen(buffer);
				char* p1=p+1;  // skip http line
				while (p[1]) {
					p[0]='\n';
					p=buffer+strlen(buffer);
				}
				ShowStatus(p1); // the additional headers
			}
		}
	}

	if (!HttpQueryInfo(HttpHandle, HTTP_QUERY_STATUS_CODE, &StatusCode, &len, &idx))
		strcpy(StatusCode,"400");
	char buffer[256];
	if (strncmp(StatusCode,"2",1)!=0) {
		strcpy(buffer,"Error: ");
	} else
		buffer[0]=0;
	{
		strcat(buffer,StatusCode);
		strcat(buffer," ");
		len=sizeof(buffer)-strlen(buffer);
		idx=0;
		if (HttpQueryInfo(HttpHandle, HTTP_QUERY_STATUS_TEXT, buffer+strlen(buffer), &len, &idx))
			ShowStatus(buffer);
	}

	return atoi(StatusCode);
}

void SetupContextBuf(pConnectSettings ConnectSettings,CONTEXTBUF* cbuf)
{
	cbuf->lastpercent=0;
	cbuf->dwError=0;
	cbuf->hCreatedRequest=NULL;
	cbuf->hHandleCreatedEvent=CreateEvent(NULL, FALSE, FALSE, NULL);
	cbuf->hRequestCompleteEvent=CreateEvent(NULL, FALSE, FALSE, NULL);
	InternetSetStatusCallback(ConnectSettings->ConnHandle,(INTERNET_STATUS_CALLBACK)&InternetCallback);
}

void CleanupContextBuf(pConnectSettings ConnectSettings,CONTEXTBUF* cbuf)
{
	CloseHandle(cbuf->hHandleCreatedEvent);
	CloseHandle(cbuf->hRequestCompleteEvent);
	InternetSetStatusCallback(ConnectSettings->ConnHandle,(INTERNET_STATUS_CALLBACK)&DummyCallback);
}

HINTERNET WINAPI AsyncHttpOpenRequest(HINTERNET hConnect,LPCTSTR lpszVerb,LPCTSTR lpszObjectName,LPCTSTR lpszVersion,LPCTSTR lpszReferrer,LPCTSTR *lplpszAcceptTypes,DWORD dwFlags,CONTEXTBUF* cbuf)
{
	HANDLE events[2];
	HINTERNET openhdl;
	ResetEvent(cbuf->hHandleCreatedEvent);
	ResetEvent(cbuf->hRequestCompleteEvent);
	events[0]=cbuf->hHandleCreatedEvent;
	events[1]=cbuf->hRequestCompleteEvent;

	openhdl=HttpOpenRequest(hConnect,lpszVerb,lpszObjectName,lpszVersion,
		lpszReferrer,lplpszAcceptTypes,dwFlags,(DWORD)cbuf);
	if (openhdl==NULL) {
		if (GetLastError() != ERROR_IO_PENDING)
        {
            return NULL;
        }
		DWORD waitret;
		BOOL looprunning=true;
		while (looprunning) {
			MSG msg;
			waitret=MsgWaitForMultipleObjects(2,&events[0], false,100,QS_ALLEVENTS);
			switch (waitret){
			case WAIT_OBJECT_0: // request complete!
				looprunning=false;
				break;
			case WAIT_OBJECT_0+1: // handle created!
				openhdl=cbuf->hCreatedRequest;
				looprunning=false;
				break;
			case WAIT_OBJECT_0+2: // a message!
				while (PeekMessage(&msg,NULL,0,0,PM_REMOVE)) {
					TranslateMessage(&msg);
					DispatchMessage(&msg);
				}
				break;
			case WAIT_TIMEOUT:
				break;
			}
			if (ProgressProc(PluginNumber,NULL,NULL,0)) {
				if (openhdl) {
					InternetCloseHandle(openhdl);
					openhdl=NULL;
					looprunning=false;
				}
			}
		}
	}
	return openhdl;
}

#define ASYNC_OK 0
#define ASYNC_FAILED 1
#define ASYNC_CANCELED_HANDLE_DELETED 2

int HandleRequestComplete(HINTERNET hRequest,CONTEXTBUF* cbuf)
{
	DWORD waitret;
	BOOL looprunning=true;
	BOOL handledeleted=false;
	BOOL ok=ASYNC_FAILED;
	DWORD LastTick=GetTickCount();
	DWORD StartTick=LastTick;
	int waitpercent=0;
	while (looprunning) {
		MSG msg;
		waitret=MsgWaitForMultipleObjects(1,&cbuf->hRequestCompleteEvent, false,100,QS_ALLEVENTS);
		switch (waitret){
		case WAIT_OBJECT_0: // request complete!
			if (cbuf->dwError) {
				ShowDetailedError("HTTP error: ",cbuf->dwError);
			}
			ok=(cbuf->dwError==0) || (cbuf->dwError==ERROR_HTTP_REDIRECT_NEEDS_CONFIRMATION);
			looprunning=false;
			break;
		case WAIT_OBJECT_0+1: // a message!
			while (PeekMessage(&msg,NULL,0,0,PM_REMOVE)) {
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
			break;
		case WAIT_TIMEOUT:
			break;
		}
		if (cbuf->lastpercent==0) {
			if (GetTickCount()-LastTick>500) {
				waitpercent+=1;
				LastTick=GetTickCount();
			}
			if (waitpercent>=100)
				waitpercent=0;
		} else {
			waitpercent=0;
			LastTick=GetTickCount();  // new: no reaction for 2 seconds _during_ transfer!
		}
		if (LastTick>StartTick+2000)
			if (ProgressProc(PluginNumber,NULL,NULL,cbuf->lastpercent+waitpercent)) {
				if (!handledeleted) {
					InternetSetStatusCallback(hRequest,(INTERNET_STATUS_CALLBACK)&DummyCallback);
					InternetCloseHandle(hRequest);
				}
				handledeleted=true;
				ok=false;
				looprunning=false;
			}
	}
	if (ok)
		return ASYNC_OK;
	else if (!handledeleted)
		return ASYNC_FAILED;
	else
		return ASYNC_CANCELED_HANDLE_DELETED;
}

int AsyncHttpSendRequest(HINTERNET hRequest,LPCTSTR lpszHeaders,DWORD dwHeadersLength,LPVOID lpOptional,DWORD dwOptionalLength,CONTEXTBUF* cbuf)
{
	INTERNET_BUFFERS bufin;

	memset(&bufin,0,sizeof(bufin));
	bufin.dwStructSize=sizeof(bufin);
	bufin.dwHeadersLength=dwHeadersLength;
	bufin.dwHeadersTotal=dwHeadersLength;
	bufin.lpcszHeader=lpszHeaders;
	bufin.dwBufferLength=dwOptionalLength;
	bufin.dwBufferTotal=dwOptionalLength;
	bufin.lpvBuffer=lpOptional;

	ResetEvent(cbuf->hRequestCompleteEvent);
	cbuf->dwError=0;
	BOOL ok=HttpSendRequest(hRequest,lpszHeaders,dwHeadersLength,lpOptional,dwOptionalLength);
	if (ok || GetLastError()!=ERROR_IO_PENDING) {  // it wasn't async, or failed
		cbuf->dwError=GetLastError();
		return ok ? ASYNC_OK : ASYNC_FAILED;
	}
	return HandleRequestComplete(hRequest,cbuf);
}

BOOL AsyncHttpSendRequestEx (HINTERNET hRequest,LPINTERNET_BUFFERS lpBuffersIn,LPINTERNET_BUFFERS lpBuffersOut,DWORD dwFlags,CONTEXTBUF* cbuf)
{
	ResetEvent(cbuf->hRequestCompleteEvent);
	cbuf->dwError=0;

	BOOL ok=HttpSendRequestEx(hRequest,lpBuffersIn,lpBuffersOut,dwFlags | HSR_ASYNC,(DWORD)cbuf);
	
	if (ok || GetLastError()!=ERROR_IO_PENDING) {  // it wasn't async, or failed
		cbuf->dwError=GetLastError();
		return ok ? ASYNC_OK : ASYNC_FAILED;
	}
	return HandleRequestComplete(hRequest,cbuf);
}

int AsyncHttpEndRequest(HINTERNET hRequest,LPINTERNET_BUFFERS lpBuffersOut,DWORD dwFlags,CONTEXTBUF* cbuf)
{
	ResetEvent(cbuf->hRequestCompleteEvent);

	cbuf->dwError=0;
	BOOL ok=HttpEndRequest(hRequest,lpBuffersOut,dwFlags,(DWORD)cbuf);
	if (ok || GetLastError()!=ERROR_IO_PENDING) {  // it wasn't async, or failed
		cbuf->dwError=GetLastError();
		return ok ? ASYNC_OK : ASYNC_FAILED;
	}
	return HandleRequestComplete(hRequest,cbuf);
}

int AsyncInternetReadFile(IN HINTERNET hFile, IN LPVOID lpBuffer, IN DWORD dwNumberOfBytesToRead, OUT LPDWORD lpdwNumberOfBytesRead,CONTEXTBUF* cbuf)
{
	ResetEvent(cbuf->hRequestCompleteEvent);
	INTERNET_BUFFERS InetBuff;
	memset(&InetBuff, 0, sizeof(InetBuff));
	InetBuff.dwStructSize = sizeof(InetBuff);
	InetBuff.lpvBuffer = lpBuffer;
	InetBuff.dwBufferLength = dwNumberOfBytesToRead;
	
	cbuf->dwError=0;
	BOOL ok=InternetReadFileEx(hFile,&InetBuff,IRF_ASYNC,(DWORD)cbuf);
	if (ok || GetLastError()!=ERROR_IO_PENDING) {  // it wasn't async, or failed
		if (ok)
			*lpdwNumberOfBytesRead=InetBuff.dwBufferLength;
		else
			*lpdwNumberOfBytesRead=0;
		cbuf->dwError=GetLastError();
		return ok ? ASYNC_OK : ASYNC_FAILED;
	}
	int ret=HandleRequestComplete(hFile,cbuf);
	if (ret==ASYNC_OK)
		*lpdwNumberOfBytesRead=InetBuff.dwBufferLength;
	else
		*lpdwNumberOfBytesRead=0;
	return ret;
}

int AsyncInternetWriteFile(HINTERNET hFile,LPCVOID lpBuffer,DWORD dwNumberOfBytesToWrite,LPDWORD lpdwNumberOfBytesWritten,CONTEXTBUF* cbuf)
{
	ResetEvent(cbuf->hRequestCompleteEvent);
	BOOL ok=InternetWriteFile(hFile,lpBuffer,dwNumberOfBytesToWrite,lpdwNumberOfBytesWritten);
	cbuf->dwError=0;
	if (ok || GetLastError()!=ERROR_IO_PENDING) {  // it wasn't async, or failed
		if (ok)
			*lpdwNumberOfBytesWritten=dwNumberOfBytesToWrite;
		else
			*lpdwNumberOfBytesWritten=0;
		cbuf->dwError=GetLastError();
		return ok ? ASYNC_OK : ASYNC_FAILED;
	}
	int ret=HandleRequestComplete(hFile,cbuf);
	if (ret==ASYNC_OK)
		*lpdwNumberOfBytesWritten=dwNumberOfBytesToWrite;
	else
		*lpdwNumberOfBytesWritten=0;
	return ret;
}

BOOL CALLBACK EnumThreadWndProc(HWND hwnd,LPARAM lParam)
{
	HWND popwnd=GetLastActivePopup(hwnd);  // find window with popup
	if (popwnd!=hwnd) {
		*(HWND*)lParam=popwnd;
		return false;
	} else
		return true;
}

BOOL CALLBACK EnumThreadWndProc2(HWND hwnd,LPARAM lParam)
{
	*(HWND*)lParam=hwnd;
	return false;
}

#define BODY_UTF8 1

int GetHeaderEncoding(char* header) // look for: Content-Type:*utf-8
{
	strlwr(header);
	char* p=strstr(header,"content-type:");
	if (p) {
		p+=13;
		if (strstr(p,"utf-8"))
			return BODY_UTF8;
	}
	return 0;
}

int GetBodyEncoding(char* body)
{
	char* p=strstr(body,"encoding=");
	if (p) {
		p+=9;
		while (p[0]=='"' || p[0]==' ' || p[0]=='\r' || p[0]=='\n' || p[0]=='\t')
			p++;
		if (strnicmp(p,"utf-8",5)==0)
			return BODY_UTF8;
	}
	return 0;
}

void appendproxyauthinfo(char* headers,char* user,char* pass,int maxlen)
{
	if (user[0]) {
		char buf1[MAX_PATH],buf2[MAX_PATH];
		strlcpy(buf1,user,MAX_PATH-2);
		strcat(buf1,":");
		strlcat(buf1,pass,MAX_PATH-2);
		MimeEncode(buf1,buf2,sizeof(buf2)-1);
		strlcat(headers,"Proxy-Authorization: Basic ",maxlen-1);
		strlcat(headers,buf2,maxlen-1);
		strlcat(headers,"\r\n",maxlen-1);
	}
}


void setproxyauthinfo(HINTERNET ConnHandle,char* proxyuser,char* proxypassword)
{
	if (proxyuser[0]) {
		InternetSetOption(ConnHandle, INTERNET_OPTION_PROXY_USERNAME,
			proxyuser, strlen(proxyuser)+1);
	}
	if (proxypassword[0]) {
		InternetSetOption(ConnHandle, INTERNET_OPTION_PROXY_PASSWORD,
			proxypassword, strlen(proxypassword)+1);
	}
}

#ifndef ERROR_INTERNET_SEC_CERT_ERRORS
#define ERROR_INTERNET_SEC_CERT_ERRORS 12055
#define ERROR_INTERNET_SEC_CERT_NO_REV 12056
#define ERROR_INTERNET_SEC_CERT_REV_FAILED 12057
#endif

int WebDavFindFirstFile(void* serverid,char* remotedir,void** davdataptr)
{
	HTTP_MEMORY_STORAGE *dirstorage;
	char dirname[3*MAX_PATH];
	pConnectSettings ConnectSettings=(pConnectSettings)serverid;
	BOOL repeatrequest=ConnectSettings->SslConnect || ConnectSettings->proxyuser[0];

	ShowStatus("=================");
    strcpy(dirname,"Get dir: ");
    strlcat(dirname,remotedir,sizeof(dirname)-1);
    ShowStatus(dirname);

httprepeatrequestlabel:
	http_create_memory_storage(&dirstorage);

	BOOL bodyisutf8=false;

	strlcpy(dirname,remotedir,sizeof(dirname)-1);
	FormValidUrl(dirname,sizeof(dirname)-1,ConnectSettings->interpreturlasutf8);
	if (strlen(dirname)>1) {
		char* p=dirname+strlen(dirname)-1;
		if (p[0]!='/')            // ADD trailing slash!
			strlcat(dirname,"/",sizeof(dirname)-1);
	}

	if (dirstorage) {
		CONTEXTBUF cbuf;
		SetupContextBuf(ConnectSettings,&cbuf);
		bodyisutf8=false;

		HINTERNET HttpHandle;
		int status=400;

		/*if (true) {
			char buffer[8192];
			HANDLE tempfile=CreateFile("f:\\temp\\testdav.txt",GENERIC_READ,FILE_SHARE_READ | FILE_SHARE_WRITE,NULL,
				OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN,NULL);
			if (tempfile) {
				DWORD read_count;
				http_storage_seek(dirstorage, 0);
				while (ReadFile(tempfile,&buffer,sizeof(buffer),&read_count,NULL) && read_count>0) {
					http_storage_write(dirstorage,buffer, read_count);
				}
				CloseHandle(tempfile);
				http_storage_seek(dirstorage, 0);
				status=200;
			}
		} else */
		{
			setproxyauthinfo(ConnectSettings->ConnHandle,ConnectSettings->proxyuser,ConnectSettings->proxypassword);

			HttpHandle=AsyncHttpOpenRequest(ConnectSettings->ConnHandle,"PROPFIND",dirname,"HTTP/1.1",NULL,NULL,
				INTERNET_FLAG_KEEP_CONNECTION | ConnectSettings->SslFlags,&cbuf);
			if (!HttpHandle)
				ShowDetailedError("HttpOpenRequest error: ",GetLastError());
			else {
				char optionalheaders[512];
	/*			char xmlbodypadded[256];
				strcpy(xmlbodypadded,propfindxmlbody);
				int l=strlen(xmlbodypadded);  // due to an error in wininet, the length must be >150!
				while (l<160) {
					strcat(xmlbodypadded,"\r\n");
					l+=2;
				}
				wsprintf(optionalheaders,"Depth: 1\r\nContent-type: text/xml; charset=\"utf-8\"\r\n Content-Length: %d\r\n",strlen(xmlbodypadded));
	*/			strcpy(optionalheaders,"Depth: 1\r\nContent-type: text/xml; charset=\"utf-8\"\r\n");
				// we append it here again, otherwise we may get an error on first connect!
				appendproxyauthinfo(optionalheaders,ConnectSettings->proxyuser,ConnectSettings->proxypassword,sizeof(optionalheaders)-1);
				// Note: The Software AG webDAV server at
				// http://tamino.demozone.softwareag.com/taminowebdavserver/yourstore
				// doesn't seem to like ANY xml body :(
				int ok=ASYNC_FAILED;
				int retrycount=0;

				do {
					ok=AsyncHttpSendRequest(HttpHandle,optionalheaders,strlen(optionalheaders),NULL,0/*xmlbodypadded,strlen(xmlbodypadded)*/,&cbuf);
					if (ok==ASYNC_CANCELED_HANDLE_DELETED) {
						repeatrequest=false;
					} else if (ok==ASYNC_FAILED) {
						//char buf[255];
						//sprintf(buf,"Error code %d",cbuf.dwError);
						//MessageBox(0,buf,"test",0);

						if (cbuf.dwError==ERROR_INTERNET_INVALID_CA ||
							cbuf.dwError==ERROR_INTERNET_INCORRECT_PASSWORD ||
							cbuf.dwError==ERROR_INTERNET_HTTP_TO_HTTPS_ON_REDIR ||
							cbuf.dwError==ERROR_INTERNET_SEC_CERT_CN_INVALID ||
							cbuf.dwError==ERROR_INTERNET_SEC_CERT_DATE_INVALID ||
							cbuf.dwError==ERROR_INTERNET_RETRY_DIALOG ||
							cbuf.dwError==ERROR_HTTP_REDIRECT_NEEDS_CONFIRMATION ||
							cbuf.dwError==ERROR_INTERNET_SEC_CERT_ERRORS ||
							cbuf.dwError==ERROR_INTERNET_SEC_CERT_NO_REV ||
							cbuf.dwError==ERROR_INTERNET_SEC_CERT_REV_FAILED ||
							cbuf.dwError==ERROR_INTERNET_SEC_CERT_REVOKED)
							{
							MessageBeep(MB_ICONQUESTION);
							HWND wnd=GetActiveWindow();
							if (wnd==NULL || GetWindowThreadProcessId(wnd,NULL)!=GetCurrentThreadId()) {
								wnd=NULL;
								EnumThreadWindows(GetCurrentThreadId(),EnumThreadWndProc,(LPARAM)&wnd);
								if (wnd==NULL)
									EnumThreadWindows(GetCurrentThreadId(),EnumThreadWndProc2,(LPARAM)&wnd);
							}
							if (ERROR_CANCELLED==InternetErrorDlg(wnd,HttpHandle,cbuf.dwError,
								FLAGS_ERROR_UI_FILTER_FOR_ERRORS |
								 FLAGS_ERROR_UI_FLAGS_GENERATE_DATA |
								 FLAGS_ERROR_UI_FLAGS_CHANGE_OPTIONS,NULL))
								break;
							if (cbuf.dwError==ERROR_INTERNET_SEC_CERT_REV_FAILED ||
								cbuf.dwError==ERROR_INTERNET_SEC_CERT_NO_REV) {  // not handled automatically
								int newflag;
								unsigned long sz;
								sz=sizeof(newflag);
								InternetQueryOption(HttpHandle,INTERNET_OPTION_SECURITY_FLAGS,&newflag,&sz);
								//sprintf(buf,"Flags: %d",newflag);
								//MessageBox(0,buf,"test",0);
								newflag|=SECURITY_FLAG_IGNORE_REVOCATION; // | SECURITY_FLAG_IGNORE_UNKNOWN_CA;
								InternetSetOption(HttpHandle,INTERNET_OPTION_SECURITY_FLAGS,&newflag,sizeof(newflag));
							}
						}
						else if (cbuf.dwError == ERROR_INTERNET_CLIENT_AUTH_CERT_NEEDED)
						{
							SetSSLCert(serverid, HttpHandle);
						}
						else
						{
							ShowDetailedError("HttpSendRequest failed: ",cbuf.dwError);
							break;
						}
					}
				} while (ok==ASYNC_FAILED && ++retrycount<5);
				if (ok==ASYNC_OK) {
					char buffer[8192];
					DWORD bytesread;
					do {
						ok=AsyncInternetReadFile(HttpHandle,&buffer,sizeof(buffer),&bytesread,&cbuf);
						if (bytesread>0) {
							http_storage_write(dirstorage,buffer, bytesread);
						}
					} while (ok==ASYNC_OK && bytesread>0);
					status=GetStatusAndShowError(HttpHandle,ConnectSettings->detailedlog);
					if ((int)status/100==2) {
						repeatrequest=false;
					}
					if (!ConnectSettings->interpreturlasutf8) {
						// get encoding of header or buffer, but only if we do not interpret UTF8 afterwards!
						char buffer[2048];
						DWORD len=sizeof(buffer)-1;
						DWORD idx=0;
						if (HttpQueryInfo(HttpHandle,HTTP_QUERY_RAW_HEADERS, buffer, &len, &idx)) {
							// look for Content-Type: text/xml; charset="utf-8"
							// or better: Content-Type:*utf-8
							// the header lines are 0-terminated, finished with double 0
							if (buffer[0]) {
								char* p=buffer;
								while (p[0]) {
									bodyisutf8=GetHeaderEncoding(p)!=0;
									if (bodyisutf8)
										break;
									p+=strlen(p)+1;
								}
							}
						}
					}
				}
				if (ok!=ASYNC_CANCELED_HANDLE_DELETED)
					InternetCloseHandle(HttpHandle);
				
				if (ConnectSettings->SslCertStore != NULL)
				{
					CertCloseStore(ConnectSettings->SslCertStore, CERT_CLOSE_STORE_FORCE_FLAG);
					ConnectSettings->SslCertStore = NULL;
				}
			}
		}
		CleanupContextBuf(ConnectSettings,&cbuf);

	  	DAV_OPENDIR_DATA *oddata=(DAV_OPENDIR_DATA*)malloc(sizeof(DAV_OPENDIR_DATA));
		DAV_RESPONSE *response_cursor = NULL;
		DAV_PROP *prop = NULL;
		int error = HT_OK;
		oddata->interpreturlasutf8=ConnectSettings->interpreturlasutf8;

		if(dirstorage->content_size>0 && int(status/100)==2)
		{
			// We only need to decode UTF8 before % conversion if we do NOT decode UTF8 AFTER conversion
			if (!oddata->interpreturlasutf8) {  // get encoding of header or buffer
				int read_count;
				char buffer[2048];

				if (!bodyisutf8) {
					http_storage_seek(dirstorage, 0);
					if (http_storage_read(dirstorage, buffer, 2047, &read_count) == HT_OK) {
						buffer[read_count]=0;
						bodyisutf8=GetBodyEncoding(buffer)!=0;
					}
					http_storage_seek(dirstorage, 0);
				}
			}
			if (ConnectSettings->detailedlog) {
				int read_count;
				char buffer[8192];
				char tempfilename[3*MAX_PATH];
				GetTempPath(260,buffer);
				ConnectSettings->TempPathUniqueValue=GetTempFileName(buffer,"DAV",ConnectSettings->TempPathUniqueValue,tempfilename);
				if (tempfilename[0]) {
					HANDLE tempfile=CreateFile(tempfilename,GENERIC_WRITE,FILE_SHARE_READ | FILE_SHARE_WRITE,NULL,
						CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN,NULL);
					if (tempfile) {
						DWORD write_count;
						http_storage_seek(dirstorage, 0);
						while (http_storage_read(dirstorage, buffer, 8192, &read_count) == HT_OK && read_count) {
							WriteFile(tempfile,&buffer,read_count,&write_count,NULL);
						}
						CloseHandle(tempfile);
						http_storage_seek(dirstorage, 0);
					}
				}
			}
			error = dav_create_multistatus_from_storage(&oddata->multistatus, (http_storage*)dirstorage,bodyisutf8);
			oddata->bodyisutf8=bodyisutf8;
			http_storage_destroy(&dirstorage);
			if (error) {
				free(oddata);
				return DAV_FAILED;
			}
			if(oddata->multistatus != NULL)
			{
				oddata->response_cursor = oddata->multistatus->first_response;
				for(response_cursor = oddata->multistatus->first_response; response_cursor != NULL; response_cursor = response_cursor->next_response)
				{
					if((prop = dav_find_prop(response_cursor, 200, 200)) != NULL)
					{
//						dav_scan_locktoken_into_database(hoststr(connection), response_cursor->href, prop);
					}
				}
			}
			oddata->directory_slash_count=getslashcount(dirname);

			*davdataptr=oddata;
			return DAV_OK;
		} else
			http_storage_destroy(&dirstorage);
		free(oddata);
	}
	if (repeatrequest) {
		repeatrequest=false;
		goto httprepeatrequestlabel;
	}
	return DAV_FAILED;
}

BOOL WebDavFindNextFile(void* serverid,void* davdataptr,WIN32_FIND_DATA *FindData)
{
	DAV_OPENDIR_DATA *oddata=(DAV_OPENDIR_DATA*)davdataptr;
	if (!oddata)
		return DAV_FAILED;
	if (dav_readdir(oddata)) {
		FindData->dwFileAttributes=0;
		strlcpy(FindData->cFileName,oddata->filename,sizeof(FindData->cFileName)-1);
		char* p=strrchr(FindData->cFileName,'/');
		if (p) {
			p[0]=0;
			FindData->dwFileAttributes=FILE_ATTRIBUTE_DIRECTORY;
		} else if (oddata->type==DAV_RESOURCETYPE_COLLECTION) {
			FindData->dwFileAttributes=FILE_ATTRIBUTE_DIRECTORY;
		}
		FindData->cAlternateFileName[0]=0;
		FindData->ftCreationTime.dwHighDateTime=0;
		FindData->ftCreationTime.dwLowDateTime=0;
		FindData->ftLastAccessTime.dwHighDateTime=0;
		FindData->ftLastAccessTime.dwLowDateTime=0;
		FindData->nFileSizeHigh=0;
		FindData->nFileSizeLow=oddata->size;

		FindData->ftLastWriteTime=oddata->mdate;
		if (oddata->mdate.dwHighDateTime==0 && oddata->mdate.dwLowDateTime==0) {
            FindData->ftLastWriteTime.dwHighDateTime=0xFFFFFFFF;
            FindData->ftLastWriteTime.dwLowDateTime=0xFFFFFFFE;
        }
		return DAV_OK;
	} else
		return DAV_FAILED;
}

int WebDavFindClose(void* serverid,void* davdataptr)
{
	if (davdataptr) {
		DAV_OPENDIR_DATA *oddata=(DAV_OPENDIR_DATA*)davdataptr;
		dav_closedir(oddata);
		free(oddata);
		davdataptr=NULL;
	}
	return DAV_OK;
}

int WebDavCreateDirectory(void* serverid,char* Path)
{
    char msgbuf[3*MAX_PATH];
	ShowStatus("=================");
    strcpy(msgbuf,"Create dir: ");
    strlcat(msgbuf,Path,sizeof(msgbuf)-1);
    ShowStatus(msgbuf);
	pConnectSettings ConnectSettings=(pConnectSettings)serverid;

	int retval=DAV_FAILED;

	char thename[3*MAX_PATH];
	strlcpy(thename,Path,sizeof(thename)-1);
	FormValidUrl(thename,sizeof(thename)-1,ConnectSettings->interpreturlasutf8);

	CONTEXTBUF cbuf;
	SetupContextBuf(ConnectSettings,&cbuf);

	setproxyauthinfo(ConnectSettings->ConnHandle,ConnectSettings->proxyuser,ConnectSettings->proxypassword);
	HINTERNET HttpHandle;
	HttpHandle=AsyncHttpOpenRequest(ConnectSettings->ConnHandle,"MKCOL",thename,"HTTP/1.1",NULL,NULL,
		INTERNET_FLAG_NO_CACHE_WRITE | INTERNET_FLAG_KEEP_CONNECTION | ConnectSettings->SslFlags,&cbuf);
	if (HttpHandle) {
		char optionalheaders[512];
		char* phdr;
		int hdrsz;
		if (ConnectSettings->proxyuser[0]) {
			optionalheaders[0]=0;
			appendproxyauthinfo(optionalheaders,ConnectSettings->proxyuser,ConnectSettings->proxypassword,sizeof(optionalheaders)-1);
			phdr=optionalheaders;
			hdrsz=strlen(optionalheaders);
		} else {
			phdr=NULL;
			hdrsz=0;
		}

		BOOL bCertTried = FALSE;
retry:		
		int ok=AsyncHttpSendRequest(HttpHandle, phdr, hdrsz, NULL, 0,&cbuf);

		if (cbuf.dwError == ERROR_INTERNET_CLIENT_AUTH_CERT_NEEDED && !bCertTried)
		{
			SetSSLCert(serverid, HttpHandle);
			bCertTried = TRUE;
			goto retry;
		}

		if (ok==ASYNC_OK) {
			int StatusCode=GetStatusAndShowError(HttpHandle,ConnectSettings->detailedlog);
			if ((int)(StatusCode/10)==20)
				retval=DAV_OK;

			if (StatusCode!=204 && StatusCode!=304) { //204= no body
				char buffer[64];
				DWORD dwSize;
				do	{ // clear reply
					ok=AsyncInternetReadFile (HttpHandle, &buffer, sizeof(buffer)-1, &dwSize,&cbuf);
				} while (dwSize != 0);
			}
		}
		if (ok!=ASYNC_CANCELED_HANDLE_DELETED)
			InternetCloseHandle(HttpHandle);

		if (ConnectSettings->SslCertStore != NULL)
		{
			CertCloseStore(ConnectSettings->SslCertStore, CERT_CLOSE_STORE_FORCE_FLAG);
			ConnectSettings->SslCertStore = NULL;
		}
	}
	CleanupContextBuf(ConnectSettings,&cbuf);
	return retval;
}

int WebDavRenameMoveFile(void* serverid,char* OldName,char* NewName,BOOL Move, BOOL Overwrite, BOOL isdir)
{
	pConnectSettings ConnectSettings=(pConnectSettings)serverid;
	BOOL retry;   // for redirects
	int retrycount;
	int retval=DAV_FAILED;
	char* operation="COPY";
	if (Move)
		operation="MOVE";

	ShowStatus("=================");
    char msgbuf[3*MAX_PATH];
    strcpy(msgbuf,operation);
    strlcat(msgbuf,": ",sizeof(msgbuf)-1);
    strlcat(msgbuf,OldName,sizeof(msgbuf)-1);
    strlcat(msgbuf,"->",sizeof(msgbuf)-1);
    strlcat(msgbuf,NewName,sizeof(msgbuf)-1);
    ShowStatus(msgbuf);

	char optionalheaders[512];
	int hdrsz;
	strcpy(optionalheaders,"Destination: http");
	if (ConnectSettings->SslConnect)
		strcat(optionalheaders,"s");    //https!
	char thename[3*MAX_PATH];
	
	strlcpy(thename,NewName,sizeof(thename)-1);
	if (isdir && ConnectSettings->apacheDirWithSlash)
		strlcatforwardslash(thename,sizeof(thename)-1);
		
	wsprintf(optionalheaders+strlen(optionalheaders),"://%s%s\r\n",ConnectSettings->server,thename);
	FormValidUrl(optionalheaders+13,sizeof(optionalheaders)-14,ConnectSettings->interpreturlasutf8);
	if (!Overwrite)
		strcat(optionalheaders,"Overwrite: F\r\n");
	appendproxyauthinfo(optionalheaders,ConnectSettings->proxyuser,ConnectSettings->proxypassword,sizeof(optionalheaders)-1);
	hdrsz=strlen(optionalheaders);
	setproxyauthinfo(ConnectSettings->ConnHandle,ConnectSettings->proxyuser,ConnectSettings->proxypassword);

	strlcpy(thename,OldName,sizeof(thename)-1);
	FormValidUrl(thename,sizeof(thename)-1,ConnectSettings->interpreturlasutf8);
	if (isdir && ConnectSettings->apacheDirWithSlash)
		strlcatforwardslash(thename,sizeof(thename)-1);

	HINTERNET HttpHandle;
	CONTEXTBUF cbuf;
	SetupContextBuf(ConnectSettings,&cbuf);
	retrycount=10;
	do {
		retry=false;
		HttpHandle=AsyncHttpOpenRequest(ConnectSettings->ConnHandle,operation,thename,"HTTP/1.1",
			NULL,NULL,
			INTERNET_FLAG_NO_CACHE_WRITE | INTERNET_FLAG_KEEP_CONNECTION | ConnectSettings->SslFlags,&cbuf);
		if (HttpHandle) {
			int ok=AsyncHttpSendRequest(HttpHandle, optionalheaders, hdrsz, NULL, 0, &cbuf);

			if (cbuf.dwError == ERROR_INTERNET_CLIENT_AUTH_CERT_NEEDED)
			{
				SetSSLCert(serverid, HttpHandle);
				retrycount--;
				continue;
			}

			if (ok==ASYNC_OK) {
				int StatusCode=GetStatusAndShowError(HttpHandle,ConnectSettings->detailedlog);
				if ((int)(StatusCode/10)==20)
					retval=DAV_OK;
				else if (!Overwrite && StatusCode==412)
					retval=DAV_EXISTS;
				
				if (StatusCode!=204 && StatusCode!=304) { //204= no body
					char buffer[64];
					DWORD dwSize;
					do	{ // clear reply
						ok=AsyncInternetReadFile (HttpHandle, &buffer, sizeof(buffer), &dwSize,&cbuf);
					} while (ok==ASYNC_OK && dwSize != 0);
				}
				// fix to some Apache versions
				if (StatusCode==301 || StatusCode==302) {  // moved permanently or temporarily!
					char thename2[3*MAX_PATH];
					DWORD len=sizeof(thename2)-1;
					DWORD idx=0;
					if (HttpQueryInfo(HttpHandle, HTTP_QUERY_LOCATION, thename2, &len, &idx)) {
						char* p=strchr(thename2+8,'/');
						if (p) {
							strcpy(thename,p);
							ShowStatus("Redirecting to new URL:");
							ShowStatus(thename);
							retry=true;
						}
					}				
				}
			}
			if (ok!=ASYNC_CANCELED_HANDLE_DELETED)
				InternetCloseHandle(HttpHandle);

			if (ConnectSettings->SslCertStore != NULL)
			{
				CertCloseStore(ConnectSettings->SslCertStore, CERT_CLOSE_STORE_FORCE_FLAG);
				ConnectSettings->SslCertStore = NULL;
			}
		}
	} while (retry && retrycount-->0);
	CleanupContextBuf(ConnectSettings,&cbuf);
	return retval;
}

#define DATABUFSIZE 32768

int WebDavDownloadFile(void* serverid,char* RemoteName,char* LocalName,BOOL alwaysoverwrite,
					   _int64 filesize,FILETIME *ft,BOOL Resume)
{
	pConnectSettings ConnectSettings=(pConnectSettings)serverid;
	_int64 sizeloaded=0;

    char msgbuf[3*MAX_PATH];
	HANDLE houtfile;

	ShowStatus("=================");
    strcpy(msgbuf,"File receive: ");
    strlcat(msgbuf,RemoteName,sizeof(msgbuf)-1);
    ShowStatus(msgbuf);

	if (Resume) {
		houtfile=CreateFile(LocalName,GENERIC_WRITE,FILE_SHARE_READ | FILE_SHARE_WRITE,NULL,
			OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN,NULL);
		if (houtfile!=INVALID_HANDLE_VALUE) {
			DWORD szh;
			sizeloaded=GetFileSize(houtfile,&szh);
			sizeloaded|=((_int64)szh)<<32;
			SetFilePointer(houtfile,0,NULL,SEEK_END);

			if (filesize<=sizeloaded) {  // local file is larger!
				CloseHandle(houtfile);
				return filesize==sizeloaded ? DAV_OK : DAV_WRITEFAILED;
			}
		}
	} else {
		houtfile=CreateFile(LocalName,GENERIC_WRITE,FILE_SHARE_READ | FILE_SHARE_WRITE,NULL,
			alwaysoverwrite ? CREATE_ALWAYS : CREATE_NEW,
			FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN,NULL);
	}
	if (houtfile==INVALID_HANDLE_VALUE) {
		int err=GetLastError();
		switch (err) {
		case ERROR_ACCESS_DENIED:return DAV_EXISTS;
		case ERROR_SHARING_VIOLATION:return DAV_EXISTS;
		default:return DAV_WRITEFAILED;
		}
	}
	int retval=DAV_READFAILED;
	BOOL connectOK=false;

	char thename[3*MAX_PATH];
	strlcpy(thename,RemoteName,sizeof(thename)-1);
	FormValidUrl(thename,sizeof(thename)-1,ConnectSettings->interpreturlasutf8);

	HINTERNET HttpHandle;
	CONTEXTBUF cbuf;
	SetupContextBuf(ConnectSettings,&cbuf);

	setproxyauthinfo(ConnectSettings->ConnHandle,ConnectSettings->proxyuser,ConnectSettings->proxypassword);

	HttpHandle=AsyncHttpOpenRequest(ConnectSettings->ConnHandle,"GET",thename,"HTTP/1.1",NULL,NULL,
		INTERNET_FLAG_KEEP_CONNECTION | ConnectSettings->SslFlags,&cbuf);
	if (HttpHandle) {
		char optionalheaders[512];
		char* phdr;
		int hdrsz;
		if (sizeloaded || ConnectSettings->proxyuser[0]) {
			if (sizeloaded)
				wsprintf(optionalheaders,"Range:bytes=%lu-\r\n",sizeloaded);
			else
				optionalheaders[0]=0;
			appendproxyauthinfo(optionalheaders,ConnectSettings->proxyuser,ConnectSettings->proxypassword,sizeof(optionalheaders)-1);
			phdr=optionalheaders;
			hdrsz=strlen(optionalheaders);
		} else {
			phdr=NULL;
			hdrsz=0;
		}
		
		BOOL bCertTried = FALSE;
retry:		
		int ok=AsyncHttpSendRequest(HttpHandle,phdr,hdrsz,NULL,0,&cbuf);

		if (cbuf.dwError == ERROR_INTERNET_CLIENT_AUTH_CERT_NEEDED && !bCertTried)
		{
			SetSSLCert(serverid, HttpHandle);
			bCertTried = TRUE;
			goto retry;
		}

		if (ok==ASYNC_OK) {
			char* pbuffer;
			DWORD bytesread,byteswritten;
			pbuffer=(char*)malloc(DATABUFSIZE);
			if (pbuffer) {
				retval=DAV_OK;
				// Make sure we don't get an error document back!!!
				int StatusCode=GetStatusAndShowError(HttpHandle,ConnectSettings->detailedlog);
				if ((int)(StatusCode/100)!=2) {  // error -> get error message
					do	{
						ok=AsyncInternetReadFile (HttpHandle, pbuffer, DATABUFSIZE, &bytesread,&cbuf);
					} while (ok==ASYNC_OK && bytesread != 0);
					retval=DAV_READFAILED;
				} else {   // all OK -> get data!
					connectOK=true;
					do {
						cbuf.lastpercent=GetPercent(sizeloaded,filesize);
						ok=AsyncInternetReadFile(HttpHandle,pbuffer,DATABUFSIZE,&bytesread,&cbuf);
						if (ok==ASYNC_OK && bytesread>0) {
							if (!WriteFile(houtfile,pbuffer,bytesread,&byteswritten,NULL)) {
								retval=DAV_WRITEFAILED;
								break;
							}
							sizeloaded+=byteswritten;
							if (UpdatePercentBar(GetPercent(sizeloaded,filesize))) {
								retval=DAV_ABORT;
								break;
							}
						}
					} while (ok==ASYNC_OK && bytesread>0);
				}
				free(pbuffer);
			}
		}
		if (ok!=ASYNC_CANCELED_HANDLE_DELETED)
			InternetCloseHandle(HttpHandle);

		if (ConnectSettings->SslCertStore != NULL)
		{
			CertCloseStore(ConnectSettings->SslCertStore, CERT_CLOSE_STORE_FORCE_FLAG);
			ConnectSettings->SslCertStore = NULL;
		}
	}
	CleanupContextBuf(ConnectSettings,&cbuf);
	SetFileTime(houtfile,NULL,NULL,ft);
	CloseHandle(houtfile);
	if (!connectOK)
		DeleteFile(LocalName);

	return retval;
}

DWORD WebDavGetFileSize(void* serverid,char* RemoteName)
{
	void* davdataptr;
	if (DAV_OK!=WebDavFindFirstFile(serverid,RemoteName,&davdataptr)) {
		SetLastError(ERROR_PATH_NOT_FOUND);
		return 0xFFFFFFFF;
	}
	DAV_OPENDIR_DATA *oddata=(DAV_OPENDIR_DATA*)davdataptr;

	if (davdataptr) {
		oddata->directory_slash_count=0;  // Important: do not skip the file itself!
		if (dav_readdir(oddata)) {
			DWORD retval=oddata->size;
			dav_closedir(oddata);
			SetLastError(0);
			return retval;
		}
	}
	SetLastError(ERROR_PATH_NOT_FOUND);
	return 0xFFFFFFFF;
}

void WebDavSetOverwriteFlag()
{
}

typedef struct {
	HINTERNET HttpHandle;
} threaddata,*threaddataptr;

DWORD WINAPI AbortThreadProc(LPVOID lpParameter)
{
	threaddataptr tdp=(threaddataptr)lpParameter;
	HINTERNET hdl;

	Sleep(100);
	if (tdp->HttpHandle) {  // maybe HttpEndRequest was successful?
		hdl=tdp->HttpHandle;
		tdp->HttpHandle=NULL;

		InternetCloseHandle(hdl);
		DWORD starttime=GetTickCount();
		do {
			MSG msg;
			while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) 
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		} while (GetCurrentTime()-starttime<5000);
	}
	return 0;
}

BOOL WebDavDeleteBeforeUpload(void* serverid)
{
	pConnectSettings ConnectSettings=(pConnectSettings)serverid;
	return ConnectSettings->deletebeforeupload;
}

int WebDavUploadFile(void* serverid,char* LocalName,char* RemoteName,DWORD resumeat)
{
	pConnectSettings ConnectSettings=(pConnectSettings)serverid;
	int retval;
    char msgbuf[3*MAX_PATH];
	ShowStatus("=================");
    strcpy(msgbuf,"File send: ");
    strlcat(msgbuf,RemoteName,sizeof(msgbuf)-1);
    ShowStatus(msgbuf);
	retval=DAV_WRITEFAILED;

	// Note: HTTP PUT does NOT currently support Content-Range!
	if (resumeat)
		return DAV_WRITEFAILED;

	HANDLE houtfile=CreateFile(LocalName,GENERIC_READ,FILE_SHARE_READ | FILE_SHARE_WRITE,
		NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN,NULL);

	if (houtfile!=INVALID_HANDLE_VALUE) {
		_int64 sizesent=0;
		DWORD filesize=GetFileSize(houtfile,NULL);

		char thename[3*MAX_PATH];
		strlcpy(thename,RemoteName,sizeof(thename)-1);
		FormValidUrl(thename,sizeof(thename)-1,ConnectSettings->interpreturlasutf8);

		HINTERNET HttpHandle;
		HCERTSTORE hCertStore = NULL;
		CONTEXTBUF cbuf;
		SetupContextBuf(ConnectSettings,&cbuf);
		setproxyauthinfo(ConnectSettings->ConnHandle,ConnectSettings->proxyuser,ConnectSettings->proxypassword);

		HttpHandle=AsyncHttpOpenRequest(ConnectSettings->ConnHandle,"PUT",thename,"HTTP/1.1",NULL,NULL,
			INTERNET_FLAG_NO_CACHE_WRITE | INTERNET_FLAG_KEEP_CONNECTION | ConnectSettings->SslFlags,&cbuf);
		if (HttpHandle) {
			INTERNET_BUFFERS BufferIn;
			int StatusCode;
			int ok;
			char buffer[8192];
			DWORD dwSize;
			char additionalheader[512];

			strcpy(additionalheader,"Content-type: application/octet-stream\r\n");
			appendproxyauthinfo(additionalheader,ConnectSettings->proxyuser,ConnectSettings->proxypassword,sizeof(additionalheader)-1);
			HttpAddRequestHeaders(HttpHandle,
				additionalheader,
				-1,HTTP_ADDREQ_FLAG_ADD | HTTP_ADDREQ_FLAG_REPLACE);

			if (ConnectSettings->usemultistepuploadmethod) {
				// First step: Upload 1 byte file -> causes authentication start!
				// 0 bytes or HttpSendRequest do NOT work!
				ShowStatus("First upload step: Send 1 byte file for authentication");

				strcpy(buffer,"1");			
				
				BOOL bCertTried = FALSE;
retry:		
				ok=AsyncHttpSendRequest(HttpHandle, NULL, 0, buffer, strlen(buffer),&cbuf);

				if (cbuf.dwError == ERROR_INTERNET_CLIENT_AUTH_CERT_NEEDED && !bCertTried)
				{
					SetSSLCert(serverid, HttpHandle);
					bCertTried = TRUE;
					goto retry;
				}

				StatusCode=GetStatusAndShowError(HttpHandle,ConnectSettings->detailedlog);
				if (StatusCode!=204 && StatusCode!=304) { //204= no body
					do	{
						char buffer2[64];
						ok=AsyncInternetReadFile (HttpHandle, buffer2, sizeof(buffer2), &dwSize,&cbuf);
					} while (ok==ASYNC_OK && dwSize != 0);
				}
			} else
				StatusCode=400;
			if (!((StatusCode>=403 && StatusCode<=406) || StatusCode>=408 || (StatusCode/100)==5)) { // check that it isn't forbidden

				// Second step: Upload 2 byte file -> causes authentication!
				// 0 bytes or HttpSendRequestEx do NOT work!
				if (ConnectSettings->usemultistepuploadmethod && ConnectSettings->use3stepuploadmethod) {
					ShowStatus("Second upload step:  Send 2 byte file for authentication");

					strcpy(buffer,"12");
					memset(&BufferIn,0,sizeof(BufferIn));
					BufferIn.dwStructSize=sizeof(BufferIn);
					BufferIn.dwBufferTotal=strlen(buffer);

					// Important: Replace content length header!
					wsprintf(additionalheader,"Content-Length: %d\r\n",strlen(buffer));
					appendproxyauthinfo(additionalheader,ConnectSettings->proxyuser,ConnectSettings->proxypassword,sizeof(additionalheader)-1);

					HttpAddRequestHeaders(HttpHandle,additionalheader,-1,HTTP_ADDREQ_FLAG_ADD | HTTP_ADDREQ_FLAG_REPLACE);

					BOOL bCertTried = FALSE;
retry1:		
					ok=AsyncHttpSendRequestEx(HttpHandle, &BufferIn, 0, HSR_INITIATE, &cbuf);

					if (cbuf.dwError == ERROR_INTERNET_CLIENT_AUTH_CERT_NEEDED && !bCertTried)
					{
						SetSSLCert(serverid, HttpHandle);
						bCertTried = TRUE;
						goto retry1;
					}

					if (ok==ASYNC_OK) {
						DWORD byteswritten,dwSize;
						ok=AsyncInternetWriteFile(HttpHandle,&buffer,strlen(buffer),&byteswritten,&cbuf);
						if (ok==ASYNC_OK)
							ok=AsyncHttpEndRequest(HttpHandle, 0, 0, &cbuf);
						if (ok==ASYNC_OK) {
							StatusCode=GetStatusAndShowError(HttpHandle,ConnectSettings->detailedlog);
							if (StatusCode!=204 && StatusCode!=304) { //204= no body
								do	{ // clear reply
									ok=AsyncInternetReadFile (HttpHandle, &buffer, sizeof(buffer), &dwSize,&cbuf);
								} while (ok==ASYNC_OK && dwSize != 0);
							}
						}
					}
				}
				// Third step: now send the actual file!
				ShowStatus("Last upload step: Send actual file");

				memset(&BufferIn,0,sizeof(BufferIn));
				BufferIn.dwStructSize=sizeof(BufferIn);
				BufferIn.dwBufferTotal=filesize;
				wsprintf(additionalheader,"Content-Length: %d\r\n",filesize);
				appendproxyauthinfo(additionalheader,ConnectSettings->proxyuser,ConnectSettings->proxypassword,sizeof(additionalheader)-1);

				HttpAddRequestHeaders(HttpHandle,additionalheader,-1,HTTP_ADDREQ_FLAG_ADD | HTTP_ADDREQ_FLAG_REPLACE);

				HANDLE hAbortThread=NULL;

				BOOL bCertTried = FALSE;
retry2:
				ok=AsyncHttpSendRequestEx(HttpHandle, &BufferIn, 0, HSR_INITIATE, &cbuf);

				if (cbuf.dwError == ERROR_INTERNET_CLIENT_AUTH_CERT_NEEDED && !bCertTried)
				{
					SetSSLCert(serverid, HttpHandle);
					bCertTried = TRUE;
					goto retry2;
				}

				if (ok==ASYNC_OK) {
					DWORD bytesread,byteswritten;
					do {
						if (ReadFile(houtfile,&buffer,sizeof(buffer),&bytesread,NULL) && bytesread>0) {
							cbuf.lastpercent=GetPercent(sizesent,filesize);
							ok=AsyncInternetWriteFile(HttpHandle,&buffer,bytesread,&byteswritten,&cbuf);
							sizesent+=byteswritten;
							if (UpdatePercentBar(GetPercent(sizesent,filesize)) && !hAbortThread) {
								retval=DAV_ABORT;
								//break - in separate thread!;

								DWORD pThreadId;
								threaddata td;
								td.HttpHandle=HttpHandle;

								hAbortThread=CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)&AbortThreadProc,
									&td,0,&pThreadId);
								Sleep(1000);
							}
						}
					} while (ok==ASYNC_OK && bytesread>0);

					if (hAbortThread)
						CloseHandle(hAbortThread);

					if (ok==ASYNC_OK && retval!=DAV_ABORT) {
						ok=AsyncHttpEndRequest(HttpHandle, 0, 0, &cbuf);
						if (ok==ASYNC_OK) {
							StatusCode=GetStatusAndShowError(HttpHandle,ConnectSettings->detailedlog);
							if ((int)(StatusCode/10)==20)
								retval=DAV_OK;
							if (StatusCode!=204 && StatusCode!=304) { //204= no body
								DWORD dwSize;
								do	{
									char buffer2[64];
									ok=AsyncInternetReadFile (HttpHandle, &buffer2, sizeof(buffer2), &dwSize,&cbuf);
								} while (ok==ASYNC_OK && dwSize != 0);
							}
						}
					}
				}
			}
			if (HttpHandle && ok!=ASYNC_CANCELED_HANDLE_DELETED)
				InternetCloseHandle(HttpHandle);

			if (ConnectSettings->SslCertStore != NULL)
			{
				CertCloseStore(ConnectSettings->SslCertStore, CERT_CLOSE_STORE_FORCE_FLAG);
				ConnectSettings->SslCertStore = NULL;
			}
		}
		CleanupContextBuf(ConnectSettings,&cbuf);
		CloseHandle(houtfile);
	} else
		retval=DAV_READFAILED;
	return retval;
}

int WebDavDeleteFile(void* serverid,char* RemoteName,BOOL isdir)
{
	pConnectSettings ConnectSettings=(pConnectSettings)serverid;
    char msgbuf[3*MAX_PATH];
	BOOL retry;   // for redirects
	int retrycount;
	ShowStatus("=================");
    strcpy(msgbuf,"File delete: ");
    strlcat(msgbuf,RemoteName,sizeof(msgbuf)-1);
    ShowStatus(msgbuf);

	char thename[3*MAX_PATH];

	strlcpy(thename,RemoteName,sizeof(thename)-1);
	FormValidUrl(thename,sizeof(thename)-1,ConnectSettings->interpreturlasutf8);
	if (isdir && ConnectSettings->apacheDirWithSlash)
		strlcatforwardslash(thename,sizeof(thename)-1);

	int retval=DAV_FAILED;
	CONTEXTBUF cbuf;
	SetupContextBuf(ConnectSettings,&cbuf);
	HINTERNET HttpHandle;
	setproxyauthinfo(ConnectSettings->ConnHandle,ConnectSettings->proxyuser,ConnectSettings->proxypassword);
	retrycount=10;
	do {
		retry=false;
		HttpHandle=AsyncHttpOpenRequest(ConnectSettings->ConnHandle,"DELETE",thename,"HTTP/1.1",NULL,NULL,
			INTERNET_FLAG_NO_CACHE_WRITE | INTERNET_FLAG_KEEP_CONNECTION | ConnectSettings->SslFlags,&cbuf);
		if (HttpHandle) {
			char optionalheaders[512];
			char* phdr;
			int hdrsz;
			if (ConnectSettings->proxyuser[0]) {
				optionalheaders[0]=0;
				appendproxyauthinfo(optionalheaders,ConnectSettings->proxyuser,ConnectSettings->proxypassword,sizeof(optionalheaders)-1);
				phdr=optionalheaders;
				hdrsz=strlen(optionalheaders);
			} else {
				phdr=NULL;
				hdrsz=0;
			}
			
			BOOL bCertTried = FALSE;
retry:
			int ok=AsyncHttpSendRequest(HttpHandle, phdr, hdrsz, NULL, 0,&cbuf);

			if (cbuf.dwError == ERROR_INTERNET_CLIENT_AUTH_CERT_NEEDED && !bCertTried)
			{
				SetSSLCert(serverid, HttpHandle);
				bCertTried = TRUE;
				goto retry;
			}

			if (ok==ASYNC_OK) {
				int StatusCode=GetStatusAndShowError(HttpHandle,ConnectSettings->detailedlog);
				if ((int)(StatusCode/10)==20)
					retval=DAV_OK;
				if (StatusCode!=204 && StatusCode!=304) { //204= no body
					char buffer[64];
					DWORD dwSize;
					do    { // clear reply
						ok=AsyncInternetReadFile(HttpHandle, &buffer, sizeof(buffer), &dwSize,&cbuf);
					} while (ok==ASYNC_OK && dwSize != 0);
				}
				// fix to some Apache versions
				if (StatusCode==301 || StatusCode==302) {  // moved permanently or temporarily!
					char thename2[3*MAX_PATH];
					DWORD len=sizeof(thename2)-1;
					DWORD idx=0;
					if (HttpQueryInfo(HttpHandle, HTTP_QUERY_LOCATION, thename2, &len, &idx)) {
						char* p=strchr(thename2+8,'/');
						if (p) {
							strcpy(thename,p);
							ShowStatus("Redirecting to new URL:");
							ShowStatus(thename);
							retry=true;
						}
					}				
				}
			}
			if (ok!=ASYNC_CANCELED_HANDLE_DELETED)
				InternetCloseHandle(HttpHandle);

			if (ConnectSettings->SslCertStore != NULL)
			{
				CertCloseStore(ConnectSettings->SslCertStore, CERT_CLOSE_STORE_FORCE_FLAG);
				ConnectSettings->SslCertStore = NULL;
			}
		}
	} while (retry && retrycount-->0);
	CleanupContextBuf(ConnectSettings,&cbuf);
	return retval;
}

int WebDavSetAttr(void* serverid,char* RemoteName,int NewAttr)
{
	ShowStatus("Set file attributes not implemented, sorry");
	return FS_FILE_NOTSUPPORTED;
}

/*
          rfc1123-date = wkday "," SP date1 SP time SP "GMT"
          date1        = 2DIGIT SP month SP 4DIGIT
                         ; day month year (e.g., 02 Jun 1982)

          time         = 2DIGIT ":" 2DIGIT ":" 2DIGIT
                         ; 00:00:00 - 23:59:59

          wkday        = "Mon" | "Tue" | "Wed"
                       | "Thu" | "Fri" | "Sat" | "Sun"

          month        = "Jan" | "Feb" | "Mar" | "Apr"
                       | "May" | "Jun" | "Jul" | "Aug"
                       | "Sep" | "Oct" | "Nov" | "Dec"
*/

int WebDavSetDateTime(void* serverid,char* RemoteName,FILETIME *LastWriteTime)
{
	ShowStatus("Set Date/Time not implemented, sorry");
	return FS_FILE_NOTSUPPORTED;
	
/*	pConnectSettings ConnectSettings=(pConnectSettings)serverid;
	char thename[MAX_PATH];
	strlcpy(thename,RemoteName,sizeof(thename)-1);
	FormValidUrl(thename,sizeof(thename)-1,ConnectSettings->interpreturlasutf8);

	int status=400;
	HINTERNET HttpHandle;
	CONTEXTBUF cbuf;
	SetupContextBuf(ConnectSettings,&cbuf);

	HttpHandle=AsyncHttpOpenRequest(ConnectSettings->ConnHandle,"PROPPATCH",thename,"HTTP/1.1",NULL,NULL,
		INTERNET_FLAG_KEEP_CONNECTION | ConnectSettings->SslFlags,&cbuf);
	if (HttpHandle) {
		char xmlbodypadded[256],optionalheaders[256];
		strcpy(xmlbodypadded,datesetxmlbody);
		int l=strlen(xmlbodypadded);  // due to an error in wininet, the length must be >150!
		while (l<160) {
			strcat(xmlbodypadded,"\r\n");
			l+=2;
		}
		wsprintf(optionalheaders,"Content-type: text/xml; charset=\"utf-8\"\r\nContent-Length: %d\r\n",strlen(xmlbodypadded));

		int ok=AsyncHttpSendRequest(HttpHandle,optionalheaders,strlen(optionalheaders),xmlbodypadded,strlen(xmlbodypadded),&cbuf);
		if (ok==ASYNC_OK) {
			status=GetStatusAndShowError(HttpHandle,ConnectSettings->detailedlog);
			if (status!=204 && status!=304) { //204= no body
				char buffer[8192];
				DWORD bytesread;
				do {
					ok=AsyncInternetReadFile(HttpHandle,&buffer,sizeof(buffer),&bytesread,&cbuf);
				} while (ok==ASYNC_OK && bytesread>0);
			}
		}
		if (ok!=ASYNC_CANCELED_HANDLE_DELETED)
			InternetCloseHandle(HttpHandle);

		if (ConnectSettings->SslCertStore != NULL)
		{
			CertCloseStore(ConnectSettings->SslCertStore, CERT_CLOSE_STORE_FORCE_FLAG);
			ConnectSettings->SslCertStore = NULL;
		}
	}
	CleanupContextBuf(ConnectSettings,&cbuf);
	return int(status/100)==2 ? FS_FILE_OK : FS_FILE_NOTSUPPORTED;
	*/
}

//*******************************************************************************

// catches callbacks coming too late!
void __stdcall DummyCallback(HINTERNET hInternet,DWORD dwContext,DWORD dwInternetStatus,LPVOID lpStatusInfo,DWORD dwStatusInfoLen)
{
	MessageBeep(0);
}

void __stdcall InternetCallback(HINTERNET hInternet,DWORD dwContext,DWORD dwInternetStatus,LPVOID lpStatusInfo,DWORD dwStatusInfoLen)
{
	INTERNET_ASYNC_RESULT *pRes = (INTERNET_ASYNC_RESULT *)lpStatusInfo;
	CONTEXTBUF* cbuf=(CONTEXTBUF*)dwContext;

	switch(dwInternetStatus) {
		case INTERNET_STATUS_HANDLE_CREATED:
		{
			cbuf->hCreatedRequest = (HINTERNET)pRes->dwResult;
			cbuf->dwError=pRes->dwError;
			SetEvent(cbuf->hHandleCreatedEvent);
			break;
		}
		case INTERNET_STATUS_REQUEST_COMPLETE:
		{
			cbuf->dwError=pRes->dwError;
			SetEvent(cbuf->hRequestCompleteEvent);
			break;
		}
	}
}

void SetSSLCert(void* serverid, HINTERNET hRequest)
{
	pConnectSettings ConnectSettings=(pConnectSettings)serverid;
	
	ConnectSettings->SslCertStore = NULL;

	if (ConnectSettings->SslConnect &&
		strlen(ConnectSettings->SslCertIssuer) > 0 &&
		strlen(ConnectSettings->SslCertSerial) > 0)
	{
		// client certificate was configured. So find the cert in the store and use it for this connection
		ConnectSettings->SslCertStore = CertOpenSystemStore(NULL, SSL_CLIENT_CERTIFICATE_STORE);

		if (ConnectSettings->SslCertStore)
		{
			// CertGetNameString here leads to unresolved external symbol although the required h file and lib 
			// is included... Therefore use LoadLibrary/GetProcAddress
			HMODULE hCryptDll = LoadLibrary("Crypt32.dll");

			if (hCryptDll)
			{
				typedef DWORD (WINAPI* pfnCertGetNameString)(PCCERT_CONTEXT pCertContext, DWORD dwType, DWORD dwFlags,
															 void *pvTypePara, LPTSTR pszNameString, DWORD cchNameString);
				pfnCertGetNameString pfnCertGetNameStringProc = reinterpret_cast<pfnCertGetNameString>(GetProcAddress(hCryptDll, "CertGetNameStringA"));

				if (pfnCertGetNameStringProc != NULL)
				{
					PCCERT_CONTEXT   pCertContext = NULL;
					char szNameString[MAX_PATH + 1] = "";

					while ((pCertContext = CertEnumCertificatesInStore(ConnectSettings->SslCertStore, pCertContext)))
					{
						DWORD dwRet = pfnCertGetNameStringProc(pCertContext, CERT_NAME_SIMPLE_DISPLAY_TYPE,
															   CERT_NAME_DISABLE_IE4_UTF8_FLAG,
															   NULL, szNameString, MAX_PATH);
						
						if (dwRet)
						{
							PCERT_INFO pCertInfo = pCertContext->pCertInfo;

							if (pCertInfo != NULL)
							{
								// Get the serial number in order to search for the cert when connecting...
								CRYPT_INTEGER_BLOB clbSerial = pCertInfo->SerialNumber;

								unsigned int iOut = 0;
								unsigned char* szB64 = base64_encode((const char*) clbSerial.pbData, clbSerial.cbData, &iOut);

								if (szB64 != NULL)
								{
									if (iOut > 0)
									{
										if (stricmp(ConnectSettings->SslCertIssuer, szNameString) == 0)
										{
											if (strnicmp(ConnectSettings->SslCertSerial, (const char*) szB64, iOut) == 0)
											{
												free(szB64);
												szB64 = NULL;

												if (InternetSetOption(hRequest, INTERNET_OPTION_CLIENT_CERT_CONTEXT,
													                  (void*) pCertContext, sizeof(CERT_CONTEXT)))
												{
													// show the cert info...
													char connbuf[MAX_PATH];
													sprintf(connbuf,"Re-Sending request using client certificate: %s", ConnectSettings->SslCertIssuer);
													LogProc(PluginNumber,MSGTYPE_CONNECT,connbuf);
												}
												else
													ShowDetailedError("InternetSetOption failed using client certificate: ",GetLastError());

												CertFreeCertificateContext(pCertContext);

												break;
											}
										}
									}
									
									free(szB64);
									szB64 = NULL;
								}
							}
						}
					}
				}

				FreeLibrary(hCryptDll);
			}
		}
	}
}