#include "http.h"

#define DAV_OK 0
#define DAV_FAILED 1
#define DAV_EXISTS 2
#define DAV_READFAILED 3
#define DAV_WRITEFAILED 4
#define DAV_ABORT 5

typedef struct dav_opendir_data DAV_OPENDIR_DATA;

#define s_quickconnect "Quick connection"

struct dav_opendir_data {
	const char *href;                // resource info
	DAV_PROP *prop;
	const char *filename;            // info extracted from href and prop
	const char *lockowner;            // for convenience
	int type;
	int size;
	FILETIME cdate;
	FILETIME mdate;
	DAV_MULTISTATUS *multistatus;    // internal stuff
	DAV_RESPONSE *response_cursor;
	int directory_slash_count;
	const char *additional_prop;
	char namebuf[1024];
	BOOL bodyisutf8;         // xml body is in utf-8
	BOOL interpreturlasutf8; // tamino: send/receive urls as utf-8
};

void* WebDavConnectToServer(char* DisplayName,char* inifilename);
BOOL WebDavConfigureServer(char* DisplayName,char* inifilename);
int WebDavCloseConnection(void* serverid);
int WebDavFindFirstFile(void* serverid,char* remotedir,void** davdataptr);
BOOL WebDavFindNextFile(void* serverid,void* davdataptr,WIN32_FIND_DATA *FindData);
int WebDavFindClose(void* serverid,void* davdataptr);
int WebDavCreateDirectory(void* serverid,char* Path);
int WebDavRenameMoveFile(void* serverid,char* OldName,char* NewName,BOOL Move, BOOL Overwrite, BOOL isdir);
int WebDavDownloadFile(void* serverid,char* RemoteName,char* LocalName,BOOL alwaysoverwrite,
					   _int64 filesize,FILETIME *ft,BOOL Resume);
DWORD WebDavGetFileSize(void* serverid,char* RemoteName);
void WebDavSetOverwriteFlag();
int WebDavUploadFile(void* serverid,char* LocalName,char* RemoteName,DWORD resumeat);
int WebDavDeleteFile(void* serverid,char* RemoteName,BOOL isdir);
int WebDavSetAttr(void* serverid,char* RemoteName,int NewAttr);
int WebDavSetDateTime(void* serverid,char* RemoteName,FILETIME *LastWriteTime);
void WebDavGetRelativePath(void* serverid,char* RelativePath,int maxlen);
BOOL WebDavDeleteBeforeUpload(void* serverid);
